
#include <math.h>
#include <stdio.h>

#include "caracteris.h"
#include "base.h"

#define preround(y) ((y>0) ? (y+0.5) : (y-0.5))

// parece que sin uso
/*
void caracteristTfd (int * crct, tmatcomplejo m, int nx, int ny)
{
  int x, y;
  int ipr, ipi, imod;
  int i;
  i = 0;
  for (y=0; y<=ny; y++){
    for (x=0; x<=nx; x++){
      if ((x != 0) || (y != 0)){
        ipr=preround(m[y][x].pr);
        ipi=preround(m[y][x].pi);
        imod=sqrt(m[y][x].pr*m[y][x].pr+m[y][x].pi*m[y][x].pi)+0.5;
        crct [i++] = ipr+128;
        crct [i++] = ipi+128;
        crct [i++] = imod;
        }
      }
    }
}
*/

void caracteristTfd2 (int * crct, tmatcomplejo m, int nx, int ny)
{
  int x, y;
  int ipr, ipi, imod, ifi;
  int i;
  i = 0;
  for (y=0; y<=ny; y++){
    for (x=0; x<=nx; x++){
      if ((x != 0) || (y != 0)){
        ipr  = preround(m[y][x].pr);
        ipi  = preround(m[y][x].pi);
        imod = sqrt(m[y][x].pr*m[y][x].pr+m[y][x].pi*m[y][x].pi)+0.5;
        ifi  = preround(atan2 (m[y][x].pr, m[y][x].pi) * 16);
        crct [i++] = ipr+128;
        crct [i++] = ipi+128;
        crct [i++] = imod;
        crct [i++] = ifi+128;
        }
      }
    }
}

void caracteristTam (int * crct, int tx, int ty)
{
  int alto, largo;
  alto  = (ty * 32) / tx;
  largo = (tx * 32) / ty;
  crct [0] = min(alto,255);
  crct [1] = min(largo,255);
}
 
void caracterisPosN (int * crct, int dyN, int dy2N, int tyN)
{
  crct [2] = max(0,dyN);
  crct [3] = min(255,dy2N);
  crct [4] = min(255,tyN);
}

void caracterist (int * crct, tmatcomplejo m, int nx, int ny,
                  int tx, int ty, int dyN, int dy2N, int tyN)
{
  caracteristTam (crct, tx, ty);
  caracterisPosN (crct, dyN, dy2N, tyN);
  caracteristTfd2 (&(crct[5]), m, nx, ny);
}

void escribeCaracteristicas (int * crct, int nx, int ny)
{
  int i, itam;
  itam = 2 + 3 + ((nx+1)*(ny+1)-1)*4;
  for (i=0; i<itam; i++)
    printf ("%3d ", crct[i]);
  printf ("\n") ;
}
