
#include <math.h>
#include <stdio.h>

#include "caracterisLib.h"
#include "config.h"
#include "grises.h"
#include "histos.h"
#include "imag.h"
// #include "segmenta0.h"
#include "tfd2d.h"

#define preround(y) ((y>0) ? (y+0.5) : (y-0.5))

void caracteristTfd1 (int * crct, tveccomplejo vc, int n)
{
  int x;
  int ipr, ipi, imod, ifi;
  int i;
  i = 0;
  for (x=1; x<=n; x++){
    ipr  = preround(vc[x].pr);
    ipi  = preround(vc[x].pi);
    imod = sqrt(vc[x].pr*vc[x].pr+vc[x].pi*vc[x].pi)+0.5;
    ifi  = preround(atan2 (vc[x].pr, vc[x].pi) * 16);
    crct [i++] = ipr+128;
    crct [i++] = ipi+128;
    crct [i++] = imod;
    crct [i++] = ifi+128;
  }
}

void caracteristLibVetct0 (int * crct, int * vect, int tam, int n)
{
  tveccomplejo vc;
  transfVector (&vc, vect, tam);
  transfVectNormSeg (vc, tam);
  caracteristTfd1 (&(crct[9]), vc, n);
  /**/
  crct[0] = (vc[0].pr + 2.0) /4.0 + 128.0;
  {int x;
   int smasan, smasdes, smenan, smendes, cmasan, cmasdes, cmenan, cmendes;
   smasan= smasdes= smenan= smendes= cmasan= cmasdes= cmenan= cmendes= 0;
   for (x=1;x<100;x++){
     if (vect[x]<0){
       cmenan ++;
       smenan += vect[x];
       }
     if (vect[x]>0){
       cmasan ++;
       smasan += vect[x];
       }
     }
   for (x=101;x<201;x++){
     if (vect[x]<0){
       cmendes++;
       smendes+= vect[x];
       }
     if (vect[x]>0){
       cmasdes++;
       smasdes+= vect[x];
       }
     }
   crct[1] = cmenan;
   crct[2] = cmasan;
   crct[3] = cmendes;
   crct[4] = cmasdes;
   crct[5] = - smenan / 200;
   crct[6] =   smasan / 200;
   crct[7] = - smendes / 200;
   crct[8] =   smasdes / 200;
   }
  /** /
  printf ("vc[0].pr %12.6f\n", vc[0].pr);
  / **/
}

void caracteristLibTira1vent (int * crct, tvent ventTira, int n)
{
  tveccomplejo vc;
  int hisV[MAXPIXH];
  int destV[MAXPIXH];
  int tam;
  tam = ventTira->tx;
  histoVer (hisV, ventTira);
  transfVector (&vc, hisV, tam);
  transfVectNormSeg (vc, tam);
  caracteristTfd1 (crct, vc, n);
  prepara0 (ventTira);
  desvTipVer2 (destV, ventTira, 0);
  transfVector (&vc, destV, tam);
  transfVectNormSeg (vc, tam);
  caracteristTfd1 (& crct[n*4], vc, n);
}

void caracteristLibTira1i (int * crct, tvent vent, int n, int i)
{
  tvent ventTira;
  int del = 80;
  ventanaEnVentanaLargHor (&ventTira, vent, i*(vent->ty)/8 - del, 2*del);
  caracteristLibTira1vent (crct, ventTira, n);
}

void caracteristLibTiras (int * crct, tvent vent, int n, int i1, int i2) 
{
  caracteristLibTira1i (crct, vent, n, i1);
  caracteristLibTira1i (& crct[8*n], vent, n, i2);
}

void escribeCaracteristica1 (int * crct, int n)
{
  int i, itam;
  itam = n*4 ;
  for (i=0; i<itam; i++)
    printf ("%3d ", crct[i]);
  printf ("\n") ;
}

