
#include <stdlib.h>
#include <stdio.h>

#include "distribDistans.h"

void creaDistds (tdistds *ndistds)
{
  tdistds distds;
  distds = (tdistds) malloc (sizeof(struct tedistds));
  distds->nd = 0;
  distds->tot = 0;
  *ndistds = distds;
}

void destruyeDistds (tdistds distds)
{
  free (distds);
}

/* la posicion mayor en la que se puede colocar 'di'
 * para que 'distds' este ordenado */
void posicionEnDistds1 (int *pos, tdistds distds, int di) 
{
  int i0, i1, im;
  int nd;
  nd = distds->nd;
  if (nd == 0){
    *pos = 0;
    }
  else if (di < distds->dis[0]){
    *pos = 0;
    }
  else if (di >= distds->dis[nd-1]){
    *pos = nd;
    }
  else {
    i0 = 0; i1 = nd-1;
    im = (i0+i1) / 2;
    while (im != i0) {
      if (di <  distds->dis[im])
	i1 = im;
      if (di >= distds->dis[im])
	i0 = im;
      im = (i0+i1) / 2;
      }
    *pos = i1;
    }
}

void anyadeDiAdistds (tdistds distds, int di)
{
  int nd;
  int i, p;
  nd = distds->nd;
  if (nd == MAXDIS) {
    printf ("ocre.distribDistans.anyadeDiAdistds: error\n");
    exit (10);
    }
  posicionEnDistds1 (&p, distds, di);
  /* desplaza -> */
  for (i=nd-1; i>=p; i--)
    distds->dis[i+1] = distds->dis[i];
  distds->dis[p]  = di;
  distds->nd = nd+1;
  distds->tot++ ;
}

void borraPosEnDistds (tdistds distds, int p)
{
  int nd;
  int i;
  nd = distds->nd;
  /* desplaza <- */
  for (i=p; i<(nd-1); i++)
    distds->dis[i] = distds->dis[i+1];
  distds->nd = nd-1;
}

void ponDiEnDistds (tdistds distds, int di)
{
  int p;
  if (distds->nd == MAXDIS) {
    p = (random() / 128) % distds->tot ;
    if (p < MAXDIS){
      borraPosEnDistds (distds, p);
      anyadeDiAdistds (distds, di);
      }
    else
      distds->tot ++;
    }
  else
    anyadeDiAdistds (distds, di);
}

void ndisEnDistds (int *ndis, tdistds distds)              
{
  *ndis = distds->nd;
}

void ndisyModaEnDistds (int *ndis, int *moda, tdistds distds)
{
  int nd;
  nd = distds->nd;
  *ndis = nd;
  if (nd == 0)
    *moda =0;
  else 
    *moda = ( distds->dis[nd/2] + distds->dis[(nd-1)/2] ) / 2 ;
}

void posicionEnDistds (int *pos, int *ndis, int *moda, tdistds distds, int di) 
{
  int i;
  int nd;
  int p;
  nd = distds->nd;
  if (nd == 0){
    *pos = 0;
    *ndis = 0;
    *moda =0;
    }
  else {
    posicionEnDistds1 (&p, distds, di);
    if ((p>0) && (distds->dis[p-1] == di)) {
      for (i=p-1; i>=0; i--)
        if (distds->dis[i] != di) break;
      i++;
      }
    else
      i=p;
    /*
    printf ("%3d %3d ", p, i);
    */
    *pos = (p+i) / 2;
    *ndis = nd;
    *moda = ( distds->dis[nd/2] + distds->dis[(nd-1)/2] ) / 2 ;
    }
}

void escribeDistds (tdistds distds) 
{
  int i;
  int nd;
  nd = distds->nd;
  printf (" MAXDIS: %3d, nd: %3d, tot: %5d ",
            MAXDIS, distds->nd, distds->tot);
  for (i=0; i<nd; i++){
    if ( (i>0) && ((i%5)==0) )
      printf ("  ");
    printf (" %3d", distds->dis[i]);
    }
  printf ("\n");
}

