
#include "imag0.h"

#ifndef _IMAG_H
#define _IMAG_H

timagf imagfalloc ();

int ntventanas ();

tvent ventBaseDeImagf (timagf imagf);

void invierteGrImagen (tvent vent);

void cambiaGrImagen (tvent vent, int *conv);

Boolean cabeRectanguloEnVentana (tvent vent, 
                                  int dx, int dy, int tx, int ty);

void rectanguloGrisEnVentana (tvent vent,
                              int dx, int dy, int tx, int ty, int gr);

void creaImagenPlana (timagf *nimag, int g, int tx, int ty);

void creaImagenMaxsReducidaDeVentana (timagf *nimagr, tvent vent, int rx, int ry);

void creaImagenReducidaDeVentana (timagf *nimagr, tvent vent, int rx, int ry);

void creaImagenReducida (timagf *nimagr, timagf imag);

void creaImagenesReducidas (timagf *vimagr, timagf imag, int n);

void creaImagenAmpliadaConMargen (timagf *nimaga, tvent vent, int amph, int ampv,
                                  int marg, int grMarg);

void creaImagenAmpliada (timagf *nimaga, tvent vent, int amph, int ampv);

void copiaImagenDeVentana (timagf *nimag, tvent vent);

void creaImagenGrisdeVentanaCapas1 (timagf *nimag, tvent vent, int *pesos);

void destruyeVentana (tvent vent);

void destruyeImagen (timagf imag);

void imagenGiradaCDerecha (timagf *nimagg, tvent vent);

void imagenGiradaCIzquierda (timagf *nimagg, tvent vent);

void imagenGiradaMVuelta (timagf *nimagg, tvent vent);

void imagenEspejoV (timagf *nimage, tvent vent);

  /* ---------- reajusta ventana  ---------- */

void reajustaPix (tvent vent);

void ventanaCreceporelNorte (tvent vent, int dely);

void ventanaCreceporelSur (tvent vent, int dely);

/* ---------- ventana en/de ventana ... ---------- */

void ventanaEnVentana (tvent * nventi, tvent vent,
                        int dx, int dy, int tx, int ty);

void ventanaEnVentanaCabeIgl (tvent * nventi, tvent vent,
                              int dx, int dy, int tx, int ty);

void ventanaEnVentanaCabeMen (tvent * nventi, tvent vent,
                              int dx, int dy, int tx, int ty);

void ventanaLimpParalogrDeVentana (tvent * nventi, tvent vent,
                                  int inclH, int y0, int y1, int inclV, int x0, int x1);

void ventanaEnVentanaCentrada (tvent * nventi, tvent vent,
                               int dx, int dy);

void ventanaDeVentana (tvent * nventi, tvent vent,
                       int dx, int dy, int tx, int ty);

void ventanaDeVentanaCabeMen (tvent * nventi, tvent vent,
                              int dx, int dy, int tx, int ty);

void copiaVentana (tvent * nventi, tvent vent);

void copiaVentanaaImagen (timagf imag, tvent vent, int dx, int dy);

void ventanaEnVentanaLargHor (tvent * nventi, tvent vent, int dy, int ty);

void ventanaEnVentanaLargVer (tvent * nventi, tvent vent, int dx, int tx);

void ventanaEnVentanaLargVerInclLimpConMargen (tvent * nventi, tvent vent,
		                               int dxb, int txb, int inclvabs);  // mrg==5

void ventanaEnVentanaLargVerInclLimpConMargen0 (tvent * nventi, tvent vent,
		                               int dxb, int txb, int inclvabs);

void ventanaAmpliaVentana (tvent * nventi, tvent vent,
                               int marg );

tvvents vventsalloc (int n);

void vventsfree (tvvents vvents);

void describeVventanas (tvvents vvents);

void describeVentana (tvent vent);

void describeVentanas (tvent vent, int niv);

void desplazamientosBase (int *dx, int *dy, int* tx, int *ty, tvent vent);

void desplazamientosBase2 (int *dx, int *dy, tvent vent);

// void ponerCarhisgrenVentana (tvent vent, tdcaracHistoGr carHisGr);

void ponerConvenVentana (tvent vent, int *conv);

int * tenerConvSobreVentana (tvent vent);

// tdcaracHistoGr carhisgrDeVentana (tvent vent);

int ktamDeVentana (tvent vent);

int valorintEncomImagen (char * nvariable, timagf imagf);

Boolean mismaBaseVentanas (tvent vent1, tvent vent2);

void unionGventanas (tvent * nvent, tvent vent1, tvent vent2);

void ventanaAlrededor (tvent *nvent, tvent vent, int tx, int ty, int escala) ;

void ventanaVertDeVentanaIncl (tvent * nventi, tvent vent);

void ventanaLimpConMargenDeVentanaIncl (tvent * nventi, tvent vent, int fondo, int marg);

void ventanaLimpConMargenPara2vents (tvent * nventi, tvent vent1, tvent vent2,
                                     int delta2resp1, int fondo, int marg);

void ventanaLimpDeVentanaIncl (tvent * nventi, tvent vent, int fondo);

void desp_contexto (int *dcx, int *dcy, tvent venBase, tvent vent, int tcx, int tcy);

void cdgVentana (int *cdgx, int *cdgy, tvent vent, int ampl);

void maximoenVentana (int *mxx, int *mxy, int *mxp, tvent vent);

tvent seleccionaSubventana (tvent vent, char *selec);

Boolean ventanaMenor(tvent v1, tvent v2);

Boolean ventanaAlsur(tvent v1, tvent v2);

tvvents vventDeLista (lista l);

void umbralizaVentana (tvent vent, int gr);

void erosionada1VentanaDeVentana (tvent vente, tvent vent,
                                  int grum, int grbl);

void erosionadaBl1VentanaDeVentana (tvent vente, tvent vent,
                                  int grum, int grng);

void erosionadaImagenDeVentana (timagf *image, tvent vent,
                                  int grum, int grbl, int n);

void erosionadaContImagenDeVentana (timagf *image, tvent vent, int n);


void erosionadaBlImagenDeVentana (timagf *image, tvent vent,
                                  int grum, int grng, int n);

void ajustadaV (tvent *nvent, tvent vent, int gr);

void ajustadaH (tvent *nvent, tvent vent, int gr);

void ajustadaVH (tvent *nvent, tvent vent, int gr);

void ajustadaVHext (tvent *nvent, tvent vent, tvent ventmx, int gr);

void transparencia1 (timagf *nimag, tvent vent, tvent vmasc, int *ft, int gr0);

void imagenPixMin (timagf *nimag, tvent vent1, tvent vent2);

void imagenX1 (timagf *nimag, tvent vent1);

// callback, desde grises? --

extern int (*fondoClaro) (tvent);

Boolean eliminarHijosTapados (tvent ventFam, tvent ventG); 

/* ---------- = ---------- */

void imagenConvolucionDeVentana (timagf *nimag, tvent vent, int ** mat_conv, int txc, int tyc, int divc);

void imagenConvolucionDeVentana_gaus2d5a (timagf *nimag, tvent vent);

// tonteria 2016 05 20,  Borrar en un mes
// void imagenConvolucionDeVentana_escq2d5a (timagf *nimag, tvent vent);

#endif /* _IMAG_H */
