
#include <stdio.h>

#include "base.h"
#include "inclina0.h"

// -------------------- Inclinacion --------------------

void pon_vprim_vult (int inc, int tu, int tv, int *vprim, int *vult)
{
  *vprim = 0;
  *vult  = tv - 1;
  if (inc > 0) *vult  -= (inc * (tu-1) + K32) / K64;
  if (inc < 0) *vprim -= (inc * (tu-1) - K32) / K64;
}

void pon_vprim_vultR (int inc, int tu, int tv, int *vprim, int *vult)
{
  *vprim = 0;
  *vult  = tv - 1;
  if (inc > 0) *vult  += (inc * (tu-1) + K32) / K64;
  if (inc < 0) *vprim += (inc * (tu-1) - K32) / K64;
}

int x_de_abAB (int a, int b, int A, int B)
{
  return (A*b + B*K64) / (K64 - a*A/K64) ;
}

int y_de_abAB (int a, int b, int A, int B)
{
  return (a*B + b*K64) / (K64- a*A/K64) ;
}

void pon_paralogr (int inclH, int y0, int y1, int inclV, int x0, int x1,
                   tcuadrltr cuadrltr)
{
  cuadrltr->xno = x_de_abAB(inclH, y0, inclV, x0);
  cuadrltr->xne = x_de_abAB(inclH, y0, inclV, x1);
  cuadrltr->xso = x_de_abAB(inclH, y1, inclV, x0);
  cuadrltr->xse = x_de_abAB(inclH, y1, inclV, x1);
  cuadrltr->yno = y_de_abAB(inclH, y0, inclV, x0);
  cuadrltr->yne = y_de_abAB(inclH, y0, inclV, x1);
  cuadrltr->yso = y_de_abAB(inclH, y1, inclV, x0);
  cuadrltr->yse = y_de_abAB(inclH, y1, inclV, x1);
  cuadrltr->x0  = min(cuadrltr->xno,cuadrltr->xso);
  cuadrltr->x1  = max(cuadrltr->xne,cuadrltr->xse);
  cuadrltr->y0  = min(cuadrltr->yno,cuadrltr->yne);
  cuadrltr->y1  = max(cuadrltr->yso,cuadrltr->yse);
}

void imprime_paralogr (tcuadrltr cuad)
{
  printf ("NO %4d,%4d      NE %4d,%4d        y0 %4d\n",
          cuad->xno, cuad->yno, cuad->xne, cuad->yne, cuad->y0);
  printf ("x0 %4d                           x1 %4d\n",
          cuad->x0, cuad->x1);
  printf ("SO %4d,%4d      SE %4d,%4d        y1 %4d\n",
          cuad->xso, cuad->yso, cuad->xse, cuad->yse, cuad->y1);
}
