
#include <stdio.h>
#include <stdlib.h>

#include "ajusteRecta.h"
// #include "arbolesLibro.h"
#include "base.h"
#include "caracterisLib.h"
#include "config.h"
#include "estad.h"
#include "grises.h"
#include "histos.h"
#include "imag.h"
#include "imagx.h"
#include "lista.h"
#include "lvent.h"
#include "libro.h"
#include "misc.h"
#include "opcns.h"
#include "pinta.h"
#include "plot.h"
// #include "segmenta0.h"
#include "senial.h"
#include "tarea.h"

/*
int reconoceScanLibro (tvent vent, int i, int xhi)
{
  int crct[400];
  int n=25;
  int prop;
  leeArbolesLibro ("/usr/share/ocre/libr");
  caracEntornoSurco11p (crct, vent, n, i, xhi);
  clasificaConArbolesLibro (crct, &prop);
  / *
   * /
  printf ("tipo scanLibro:%3d\n", prop);
  return prop;
}
*/

void combinaV1xkentrev2xv2 (int * vres, int * v1, int * v2, int k, int tam, int incl)
{
  int x;
  for (x=0; x < tam; x++) {
    /* destV no esta definido al final cuando la inclinacion != 0 */
    if (x < (tam - abs(incl))) {
      vres[x] = v1[x] * k / (v2[x] * v2[x] + 100);
      }
    else {
      vres[x] = v1[x] * k / (v2[tam-abs(incl)-1] * v2[tam-abs(incl)-1]);
      }
    }
}

void combinaHist (int * hiscomb, int * his1, int * his2, int porc, int tam, int incl)
{
  int x;
  int porc2;
  porc2 = 100 - porc;
  for (x=0; x < tam; x++) {
    /* destV no esta definido al final cuando la inclinacion != 0 */
    if (x < (tam - abs(incl))) {
      hiscomb[x] = (his1[x]*porc + his2[x]*porc2) / 100;
      }
    else {
      hiscomb[x] = his1[x];
      }
    }
}

void pintaDosRayasEnSurco (tvent ventTira, int xh)
{
  int xizq, xder;
  /* * /
  printf ("minimo en: %4d\n", xh);
  / * */
  xizq = xh - 2 ;
  xder = xh + 2 ;
  pintaRvn (ventTira, xizq, 0, ventTira->ty-1, 3);
  pintaRvn (ventTira, xder, 0, ventTira->ty-1, 3);
}

int dondeSurco01p (tvent vent, int n, tposSurco posSurco)
{
  tvent ventTira;
  int hisV[MAXPIXH];
  int destV[MAXPIXH];
  int *destVprom2;
  int destVcuad[MAXPIXH];
  // int *destVprom;
  int hvMasDtcv[MAXPIXH];
  int xh, xh1, xh2;
  int * hvMasDtcvProm;
  int tx;
  int del = 40;
  int inclinv;
  tx = vent->tx;
  prepara0 (vent);
  ventanaEnVentanaLargHor (&ventTira, vent, n*(vent->ty)/8 - del, 2*del);
  histoVer (hisV, ventTira);
  prepara0 (ventTira);
  if (X_opcion)
    inclinv = X_valori[0];
  else
    inclinv = 0;
  desvTipVer2 (destV, ventTira, inclinv);
  convolucionPromedio (&destVprom2, destV, tx, 50);
  acuadr (destVcuad, destVprom2, tx);
  combinaHist (hvMasDtcv, hisV, destVcuad, 40, tx, 0);
  convolucionPromedio (&hvMasDtcvProm, hvMasDtcv, tx, 11);
  switch (posSurco) {
    case posSurco_ce :
      xh = posminv3c(hvMasDtcvProm, (tx*20)/100, (tx*80)/100);
      break ;
    case posSurco_le :
      xh = posminv3c(hvMasDtcvProm, (tx*01)/100, (tx*33)/100);
      break ;
    case posSurco_ri :
      xh = posminv3c(hvMasDtcvProm, (tx*67)/100, (tx*99)/100);
      break ;
    case posSurco_lr :
      xh1 = posminv3c(hvMasDtcvProm, (tx*01)/100, (tx*27)/100);
      xh2 = posminv3c(hvMasDtcvProm, (tx*73)/100, (tx*99)/100);
      if (hvMasDtcvProm[xh1] <= hvMasDtcvProm[xh2])
	xh = xh1;
      else
	xh = xh2;
      break ;
    default:
      fprintf(stderr,"Unhandled case in libro.dondeSurco01p\n");
      exit(1);
    }
  return xh;
}

int dondeSurcos0 (tvent vent, tposSurco posSurco)
{
  int x[9], x0[9], dx[9];
  int i;
  for (i=2; i<=6; i++)
    x0[i] = x[i] = dondeSurco01p (vent, i, posSurco);
  ordenaVint2 (x0, 2, 6);
  for (i=2; i<=4; i++)
    dx [i] = x0[i+2] - x0[i];
  i = posminv3(dx, 2, 4);
  return (x0[i]+x0[i+1]+x0[i+2])/3 ;
}

void ventanaSurco11p (tvent *nventTira, int *pdx, int *ptx, tvent vent,  int i, int xc)
{
  int del = 40;
  int tx, dx, dx0 ;
  tx = (vent->tx * 15)/100;
  dx0 = xc - tx/2;
  dx = min( max(0, dx0), vent->tx - tx) ;
  ventanaEnVentana (nventTira, vent, dx, i*(vent->ty)/8 - del, tx, 2*del);
  *pdx = dx;
  *ptx = tx;
}

void caracEntornoSurco11p (int * crct, tvent vent, int n, int i, int xc)
{
  tvent ventTira;
  int tx, dx ;
  int hisV[MAXPIXH];
  int destV[MAXPIXH];
  int destVcuad[MAXPIXH];
  int *destVprom2;
  int hisVyvuCen[201];
  int inclinv;
  /*
  ventanaSurco11p (&ventTira, &dx, &tx, vent, i, xc);
  caracteristLibTira1vent (crct, ventTira, n);
  */
  ventanaSurco11p (&ventTira, &dx, &tx, vent, i, xc);
  histoVer (hisV, ventTira);
  prepara0 (ventTira);
  if (X_opcion)
    inclinv = X_valori[0];
  else
    inclinv = 0;
  desvTipVer2 (destV, ventTira, inclinv);
  {
  // int nh;
  int xmin;
  int hisVMx[MAXPIXH];
  int hisVyvu[MAXPIXH];
  int hvMasDtcv[MAXPIXH];
  int * hvMasDtcvProm;
  int x, xx, x0, x1;
  histoVerModa(hisVMx, ventTira, 1);
  convolucionPromedio (&destVprom2, destV, tx, 30);
  acuadr (destVcuad, destVprom2, tx);
  combinaHist (hvMasDtcv, hisV, destVcuad, 60, tx, 0);
  convolucionPromedio (&hvMasDtcvProm, hvMasDtcv, tx, 3);
  xmin = posminv (hvMasDtcv, tx);
  for (x=0; x<tx; x++)
    hisVyvu [x] = hisVMx[(x+xmin)/2] + hisVMx[(x+xmin+1)/2] -
	          hisVMx[x]          - hisVMx[xmin] ;
  /* copia centrado a vector 0..200 */
  if (xmin < 100)
    for (x=0; x<(100-xmin); x++)
       hisVyvuCen[x] =hisVyvu[0];
  x0=max(0, xmin-100);
  x1=min(tx-1, xmin+100);
  for (xx=x0; xx<=x1; xx++)
     hisVyvuCen[xx-xmin+100] =hisVyvu[xx];
  if ((xmin+100) >= tx)
    for (x=tx-(xmin-100); x<=200; x++)
       hisVyvuCen[x] =hisVyvu[tx-1];
  for (x=0; x<=200; x++) {
    }
  }
  caracteristLibVetct0 (crct, hisVyvuCen, 201, 50);
}

int dondeSurco11p (tvent vent, int i, int xc, tscanLibro scanLibro)
{
  tvent ventTira;
  int hisV[MAXPIXH];
  int *hisVprom;
  int destV[MAXPIXH];
  int *destVprom2;
  int hvMasDtcv[MAXPIXH];
  int dif[MAXPIXH];
  int destVcuad[MAXPIXH];
  // int *destVprom;
  // int x0, x1;
  int xh;
  int * hvMasDtcvProm;
  int dxx;
  int xmax, dh, x;
  int xcr;
  int tx, dx;
  int inclinv;
  ventanaSurco11p (&ventTira, &dx, &tx, vent, i, xc);
  histoVer (hisV, ventTira);
  prepara0 (ventTira);
  if (X_opcion)
    inclinv = X_valori[0];
  else
    inclinv = 0;
  desvTipVer2 (destV, ventTira, inclinv);
  /** /
  {
  int nh;
  int xmin;
  int hisVMx[MAXPIXH];
  int hisVyvu[MAXPIXH];
  histoVerMediaMaxs(hisVMx, ventTira, 5);
      convolucionPromedio (&destVprom2, destV, tx, 30);
      acuadr (destVcuad, destVprom2, tx);
      combinaHist (hvMasDtcv, hisV, destVcuad, 60, tx, 0);
      convolucionPromedio (&hvMasDtcvProm, hvMasDtcv, tx, 3);
      xh = posminv (hvMasDtcv, tx);
  / ** /
  xmin = posminv (hisVMx, tx);
  / ** /
      xmin = xh;
  printf ("xmin %4d\n", xmin);
  for (x=0; x<tx; x++)
    hisVyvu [x] = hisVMx[(x+xmin)/2] + hisVMx[(x+xmin+1)/2] -
	          hisVMx[x]          - hisVMx[xmin] ;
  presentaHistoVer (&nh, hisVMx, ventTira, "sal26v01.dat", "sal26v01.gpt");
  para ();
  }
  / **/
  switch (scanLibro) {
    case scanLibro_gg:
      convolucionPromedio (&destVprom2, destV, tx, 30);
      acuadr (destVcuad, destVprom2, tx);
      combinaHist (hvMasDtcv, hisV, destVcuad, 60, tx, 0);
      convolucionPromedio (&hvMasDtcvProm, hvMasDtcv, tx, 3);
      xh = posminv (hvMasDtcv, tx);
      break;
    case scanLibro_bg:
      /*
    case scanLibro_gb:
     */
      convolucionPromedio (&hisVprom, hisV, tx, 1);
      xmax = posmaxv3c (hisVprom, 1, tx-3);
      xcr = xc - dx;
      /*
      if (xmax == xcr) {
        printf ("xmax: %4d xcr: %4d hvp[-1] %4d hvp[0] %4d hvp[1] %4d\n",
		        xmax, xcr, hisVprom[xmax-1], hisVprom[xmax], hisVprom[xmax+1]);
        }
        */
      if (xmax < xcr) {
        /* bg */
        dh = hisVprom[xmax] - hisVprom[xcr];
        dxx = xcr -xmax;
        for (x=xmax; x<=xcr; x++)
          dif[x] = hisVprom [x] - (hisVprom [xcr] + (xcr - x) * dh / dxx) ;
        xh = posmaxv3c (dif, xmax, xcr);
        for (;xh <=xcr; xh++)
          if (hisVprom[xh] < (hisVprom[xcr]+(dh*88)/100))
	    break;
        }
      if (xmax > xcr) {
          /* gb */
        dh = hisVprom[xcr] - hisVprom[xmax];
        dxx = xmax -xcr;
        for (x=xcr; x<=xmax; x++)
          dif[x] = hisVprom [x] - (hisVprom [xcr] + (x - xcr) * dh / dxx) ;
        xh = posmaxv3c (dif, xcr, xmax);
        for (;xh >=xcr; xh--)
          if (hisVprom[xh] < (hisVprom[xcr]+(dh*88)/100))
	    break;
        }
      break;
    case scanLibro_gb:
      {
       int del;
       int hisVMx[MAXPIXH];
       histoVerMediaMaxs(hisVMx, ventTira, 5);
       xh = posMaxAbsDer2 (hisVMx, tx, &del);
      }
      break;
    default:
      fprintf(stderr,"Unhandled case in libro.c\n");
      exit(1);
    }
  xh += dx;
  return xh;
}

void ajusteRectaAsurcoQuitando2 (int *xh, int vent_ty, tajur ajusur)
{
  int q1, q2;
  int i;
  double d;
  double sumd, sumdmin;
  int q1min, q2min;
  int ip=2, iu=6;
  for (q1=ip; q1<iu; q1++)
    for (q2=q1+1; q2<=iu; q2++){
      acerosdAjusteRecta (ajusur);
      for (i=ip; i<=iu; i++)
	if ((i != q1) && (i != q2))
	  anyadedAAjusteRecta (ajusur, xh[i], vent_ty*i/8) ;
      calculaAjusteRecta (ajusur) ;
      sumd = 0.0;
      for (i=ip; i<=iu; i++)
	if ((i != q1) && (i != q2)) {
          d = distanciaXarectaAjuste (ajusur, xh[i], vent_ty*i/8);
          sumd += d*d;
	  }
      if (((q1 == ip) && (q2 == (ip+1) )) || (sumd < sumdmin)){
	q1min = q1;
	q2min = q2;
	sumdmin = sumd;
        }
      }
  acerosdAjusteRecta (ajusur);
  for (i=ip; i<=iu; i++)
    if ((i != q1min) && (i != q2min))
      anyadedAAjusteRecta (ajusur, xh[i], vent_ty*i/8) ;
  calculaAjusteRecta (ajusur) ;
}

void ajusteRectaAsurco (int *xh, int vent_ty, int *x0, int *x1)
{
  tajur ajusur;
  int lx0,lx1;
  int i;
  // int dx[9];
  int sumd;
  double d;
  nuevodAjusteRecta (&ajusur);
  for (i=2; i<=6; i++) 
    anyadedAAjusteRecta (ajusur, xh[i], vent_ty*i/8) ;
  calculaAjusteRecta (ajusur) ;
  /* */
  sumd = 0.0;
  for (i=2; i<=6; i++) {
    d = distanciaXarectaAjuste (ajusur, xh[i], vent_ty*i/8);
    sumd += d*d;
    // dx[i] = abs(d);
    /*
    printf ("d: %8.3f i: %4d dx[i]: %4d\n",d, i, dx[i]);
    */
    }
  if (sumd > 100.0){
    ajusteRectaAsurcoQuitando2 (xh, vent_ty, ajusur);
    /*
    for (i=2; i<=6; i++) {
      d = distanciaXarectaAjuste (ajusur, xh[i], vent_ty*i/8);
      dx[i] = abs(d);
      printf ("d: %8.3f i: %4d dx[i]: %4d\n",d, i, dx[i]);
      }
     */
    }
  lx0 = ajusur->by ;
  lx1 = lx0 + (vent_ty - 1) * ajusur->ay ;
  /* * /
  printf ("ay:%12.5f by:%12.5f\n", ajusur->ay, ajusur->by);
  printf ("ax:%12.5f bx:%12.5f\n", ajusur->ax, ajusur->bx);
  printf ("x0:%6d  x1:%6d ty:%6d\n", lx0, lx1, vent_ty-1);
  / * */
  *x0 = lx0;
  *x1 = lx1;
}

void dondeSurco (tvent vent, tscanLibro scanLibro, tposSurco posSurco, int *x0, int *x1)
{
  int xh[9];
  int i;
  int xc;
  xc = dondeSurcos0 (vent, posSurco);
  for (i=2; i<=6; i++) {
    xh[i] = dondeSurco11p (vent, i, xc, scanLibro);
    /*
    printf ("%4d %4d\n", i, xh[i]);
    */
    }
  ajusteRectaAsurco (xh, vent->ty, x0, x1);
}

void segmentaLibroPaginas  (tvent vent, tvent *nventIz, tvent *nventDe)
{
  int x0, x1;
  int xmin, xmax;
  // double r;
  tvent ventIz, ventDe;
  tscanLibro scanLibro;
  lista paginas;
  tposSurco posSurco;
  posSurco = posSurco_le;
  posSurco = posSurco_ce;
  /**/
  scanLibro = scanLibro_gg;
  /** /
  scanLibro = reconoceScanLibro (vent);
  / **/
  dondeSurco (vent, scanLibro, posSurco, &x0, &x1);
  /** /
  printf ("x0:%6d  x1:%6d r:%7.4f\n", x0, x1, r);
  / **/
  xmin = min(x0, x1)-20;
  xmax = max(x0, x1)+20;
  ventanaEnVentanaLargVer (&ventIz, vent,    0, xmin);
  ventanaEnVentanaLargVer (&ventDe, vent, xmax, vent->tx - xmax);
  /*
  ventanaEnVentanaLargVer (&ventIz, vent,    0, xmax);
  ventanaEnVentanaLargVer (&ventDe, vent, xmin, vent->tx - xmin);
  */
  /** /
  {int nh;
  presentaVentana (&nh, ventIz, "sal26iz.pgm", 1);
  // presentaVentana (ventDe, "sal26de.pgm", 1);
  presentaVentanayPara (ventDe, "sal26de.pgm", 1);
  }
  / **/
  *nventIz = ventIz;
  *nventDe = ventDe;
  paginas = listaNueva ();
  anyadeVentana (paginas, ventIz);
  anyadeVentana (paginas, ventDe);
  vent->lvint = paginas ;
  /**/
}
