
#include <stdio.h>
#include <stdlib.h>

#include "base.h"
#include "grises.h"
// #include "inclfont.h"
#include "imag.h"
#include "imagio.h"
#include "inclina0.h"
#include "inclina.h"
#include "line.h"
#include "lista.h"
#include "pinta.h"

// -------------------- raya --------------------

tline2 nuevaRaya20 ()
{
  tline2 line;
  line = (tline2) malloc (sizeof(struct teline2));
  return line ;
}

tline nuevaRaya (int u0, int v0, int u1, int v1)
{
  tline line;
  line = (tline) malloc (sizeof(struct teline));
  line -> u0 = u0 ;
  line -> u1 = u1 ;
  line -> v0 = v0 ;
  line -> v1 = v1 ;
  line -> hv = ' ';
  line -> bn = ' ';
  line -> incl = 0;
  return line ;
}

tline copiaRaya (tline line)
{
  tline nline;
  nline =  nuevaRaya (line->u0, line->v0, line->u1, line->v1);
  nline->hv   = line->hv ;
  nline->bn   = line->bn ;
  nline->incl = line->incl ;
  return nline;
}

tline desplazadauRaya (tline line, int du)
{
  tline nline;
  int dv;
  nline = copiaRaya (line);
  dv = - (du * line->incl +32768) / 65576;
  nline->v0 += dv;
  nline->v1 += dv;
  nline->u0 += du;
  nline->u1 += du;
  return nline;
}

void anyadeRaya1 (lista lineas, int u0, int v0, int u1, int v1)
{
  tline line;
  line = nuevaRaya (u0, v0, u1, v1);
  aniadeafinlista (lineas, (tline) line);
}

void anyadeRaya (lista lineas, tline line)
{
  aniadeafinlista (lineas, (tline) line);
}

void leeRaya (tline *line)
{
  int u0, v0, u1, v1;
  scanf ("%d %d  %d %d", &u0, &v0, &u1, &v1);
  *line = nuevaRaya (u0, v0, u1, v1);
}

void leeRayas (lista *nlineas)
{
  tline line;
  lista lineas;
  lineas = listaNueva ();
  leeRaya (&line);
  while (line->u0 >= 0) {
    anyadeRaya (lineas, line);
    leeRaya (&line);
    }
  *nlineas = lineas;
}

void ponInclinacionEnRayas (lista lineas, int inclinacion)
{
 tnodol nodol;
 for (nodol=lineas->primero; nodol != 0L; nodol=nodol->siguiente)
   ((tline) nodol->aitem)->incl = inclinacion;
}

void ponTipohvEnRayas (lista lineas, char tipohv)
{
 tnodol nodol;
 for (nodol=lineas->primero; nodol != 0L; nodol=nodol->siguiente)
   ((tline) nodol->aitem)->hv = tipohv;
}

void ponTipobnEnRayas (lista lineas, char tipobn)
{
 tnodol nodol;
 for (nodol=lineas->primero; nodol != 0L; nodol=nodol->siguiente)
   ((tline) nodol->aitem)->bn = tipobn;
}

void imprimeRaya (tline line)
{
  printf ("%4d %4d  %4d %4d  %4d %4d %c %c",
	   line->u0, line->v0, line->u1, line->v1,
           line->u1-line->u0 + 1,  line->v1-line->v0 + 1, line->hv, line->bn);
  if (line->incl != 0)
    printf (" %4d\n", line->incl);
  else
    printf ("\n");
}

void imprimeRayas (lista lineas)
{
  int i=0;
  tnodol nodol;
  printf ("  n   u0   v0    u1   v1    tu   tv \n");
  printf (" --- ---- ----  ---- ----  ---- ----\n");
  if (longLista (lineas) > 0) 
    for (nodol = lineas->primero; nodol != 0L;nodol = nodol->siguiente) {
      printf ("%4d ", i);
      imprimeRaya ( (tline) nodol->aitem );
      i++ ;
      }
}

void imprimeRayasCab (lista lineas, char *text)
{
  printf ("%s\n", text);
  imprimeRayas (lineas);
}

void imprimeGruposRayasCab (lista grLineas, char *text)
{
  int i=0;
  tnodol nodol;
  if (longLista (grLineas) > 0) 
    for (nodol = grLineas->primero; nodol != 0L;nodol = nodol->siguiente) {
      printf ("  %4d ", i);
      imprimeRayasCab ( (lista) nodol->aitem, text);
      i++ ;
      }
  printf ("\n");
}

int sumaAnchoRayas (lista lineas)
{
  int sum=0;
  tnodol nodol;
  tline linea;
  for (nodol = lineas->primero; nodol != 0L;nodol = nodol->siguiente) {
    linea = (tline) nodol->aitem ;
    sum += linea->v1 - linea->v0 + 1 ;
    }
  return sum ;
}

int u0_de_linea (tpgen l)
{
  return  ((tline) l) -> u0;
}

int u1_de_linea (tpgen l)
{
  return  ((tline) l) -> u1;
}

int v0_de_linea (tpgen l)
{
  return  ((tline) l) -> v0;
}

int v1_de_linea (tpgen l)
{
  return  ((tline) l) -> v1;
}

//************************ xxxxx **********************

int areaDeSegmento (tline s)
{
  return (s->u1 - s->u0 + 1)* (s->v1 - s->v0 + 1);
}

int areaDeSegmentos (lista segs)
{
  int s=0;
  tnodol nodol;
  for (nodol = segs->primero; nodol != 0L;nodol = nodol->siguiente) {
    s += areaDeSegmento ( (tline) nodol->aitem );
    }
  return s ;
}

void anyadeSiBien (lista lsg, int u0, int v0, int u1, int v1)
{
  if ( (u1 > u0) &&
       (v1 > v0)    )
    anyadeRaya1 (lsg, u0, v0, u1, v1);
}

void segmentosHastaSegDerechaoAbajo (lista *nsegmentos, tline stext, tline slim)
{
  lista segmts;
  segmts = listaNueva ();
  anyadeSiBien (segmts, stext->u0, stext->v0, slim->u0-1, stext->v1);
  anyadeSiBien (segmts, max(stext->u0, slim->u0),
                        stext->v0,
                        min(stext->u1, slim->u1),
		        slim->v0-1);
  anyadeSiBien (segmts, slim->u1+1, stext->v0, stext->u1, stext->v1);
  *nsegmentos = segmts;
}

void segmentosHastaSegIzquierdaoArriba (lista *nsegmentos, tline stext, tline slim)
{
  lista segmts;
  segmts = listaNueva ();
  anyadeSiBien (segmts, stext->u0, stext->v0, slim->u0-1, stext->v1);
  anyadeSiBien (segmts, max(stext->u0, slim->u0),
                        slim->v1+1,
                        min(stext->u1, slim->u1),
		        stext->v1);
  anyadeSiBien (segmts, slim->u1+1, stext->v0, stext->u1, stext->v1);
  *nsegmentos = segmts;
}

Boolean disjuntosSegmentos (tline s1, tline s2)
{
  return (s1->u1 < s2->u0) || (s2->u1 < s1->u0) ||
         (s1->v1 < s2->v0) || (s2->v1 < s1->v0)    ;
}

void segmentosHastaListaSegDerechaoAbajo (lista *nsegsDer, tline segDer, lista sslim)
{
  tnodol nodoltx, nodoltxsig, nodollm;
  lista segsDer, segs1;
  segsDer = listaNueva ();
  anyadeRaya (segsDer, segDer);
  for (nodollm = sslim->primero; nodollm != 0L;nodollm = nodollm->siguiente) {
    for (nodoltx = segsDer->primero; nodoltx != 0L;nodoltx = nodoltxsig) {
      nodoltxsig = nodoltx->siguiente ;
      if ( ! disjuntosSegmentos ((tline) nodoltx->aitem, (tline) nodollm->aitem ) ) {
        segmentosHastaSegDerechaoAbajo (&segs1, (tline) nodoltx->aitem,
		                                (tline) nodollm->aitem );
        substituyePorListaNodo  (segsDer, segs1, nodoltx);
	free (nodoltx->aitem);
	free (nodoltx);
        }
      }
    }
  *nsegsDer = segsDer;
}

void segmentosHastaListaSegIzquierdaoArriba (lista *nsegsIzq, tline segIzq, lista sslim)
{
  tnodol nodoltx, nodoltxsig, nodollm;
  lista segsIzq, segs1;
  segsIzq = listaNueva ();
  anyadeRaya (segsIzq, segIzq);
  for (nodollm = sslim->primero; nodollm != 0L;nodollm = nodollm->siguiente) {
    for (nodoltx = segsIzq->primero; nodoltx != 0L;nodoltx = nodoltxsig) {
      nodoltxsig = nodoltx->siguiente ;
      if ( ! disjuntosSegmentos ((tline) nodoltx->aitem, (tline) nodollm->aitem ) ) {
        segmentosHastaSegIzquierdaoArriba (&segs1, (tline) nodoltx->aitem,
		                                (tline) nodollm->aitem );
        substituyePorListaNodo  (segsIzq, segs1, nodoltx);
	free (nodoltx->aitem);
	free (nodoltx);
        }
      }
    }
  *nsegsIzq = segsIzq;
}

int areaMenorSegsIzqDer (tline lin, lista segsLim, int tamv)
{
  tline sd, si;
  lista segsDer, segsIzq ;
  int areaDer, areaIzq ;
  sd = nuevaRaya (lin->u0, lin->v1+1, lin->u1, tamv-1);
  segmentosHastaListaSegDerechaoAbajo (&segsDer, sd, segsLim);
  areaDer = areaDeSegmentos (segsDer);
  liberaItemsNodosYlista (segsDer);
  si = nuevaRaya (lin->u0, 0, lin->u1, lin->v0 - 1);
  segmentosHastaListaSegIzquierdaoArriba (&segsIzq, si, segsLim);
  areaIzq = areaDeSegmentos (segsIzq);
  liberaItemsNodosYlista (segsIzq);
  return  min(areaIzq, areaDer) ;
}

void tomaLineasLim (lista *nlineasLim, lista blin, int tamv)
{
  // atencion, se cambia blin
  lista lineasLim;
  tnodol nodolmax;
  int n;
  lineasLim = listaNueva ();
  for (n=0; n<5; n++) {
    tnodol nodol;
    int arminmax, armin;
    arminmax = 0;
    for (nodol = blin->primero; nodol != (tnodol) 0L; nodol = nodol->siguiente) {
      armin = areaMenorSegsIzqDer ((tline) nodol->aitem, lineasLim, tamv);
      if (armin > arminmax) {
	arminmax = armin;
	nodolmax = nodol;
	}
      }
    anyadeRaya (lineasLim, (tline) nodolmax->aitem);
    eliminaNdelista (blin, nodolmax);
    }
  *nlineasLim = lineasLim;
}

Boolean tumenor(tpgen gl, tpgen gumb)
{
  tline l;
  int umb;
  l = (tline) gl;
  umb = (int) gumb;
  return (l->u1 - l->u0 + 1) < umb;
}

Boolean tvmenor(tpgen gl, tpgen gumb)
{
  tline l;
  int umb;
  l = (tline) gl;
  umb = (int) gumb;
  return (l->v1 - l->v0 + 1) < umb;
}

Boolean tvmayor(tpgen gl, tpgen gumb)
{
  tline l;
  int umb;
  l = (tline) gl;
  umb = (int) gumb;
  return (l->v1 - l->v0 + 1) > umb;
}

//       u: longitud, v: anchura

void eliminaLineasMenores (lista lineas, int tumin)
{
  eliminaDeListaSiFuncEResul (lineas, (tpgen) tumin, tumenor, TRUE);
}

void eliminaLineasMasanchas (lista lineas, int tvmax)
{
  eliminaDeListaSiFuncEResul (lineas, (tpgen) tvmax, tvmayor, TRUE);
}

void eliminaLineasMenosanchas (lista lineas, int tvmin)
{
  eliminaDeListaSiFuncEResul (lineas, (tpgen) tvmin, tvmenor, TRUE);
}

// -------------------- --------------------

void line2de1 (tline2 l2, tline l)
{
  int incl, deltav0, deltav1;
  l2->u0   = l->u0;  
  l2->u1   = l->u1;  
  l2->hv   = l->hv;  
  l2->bn   = l->bn;  
  l2->incl = l->incl;  
//
  incl     = l->incl;
  deltav0  = inclf_desvx(incl,l->u0) ;
  deltav1  = inclf_desvx(incl,l->u1) ;
  l2->v00   = l->v0 + deltav0;
  l2->v01   = l->v0 + deltav1;
  l2->v10   = l->v1 + deltav0;
  l2->v11   = l->v1 + deltav1;
}

void line1de2 (tline l, tline2 l2)
{
  int incl, deltav0, deltav1;
  l->u0   = l2->u0;  
  l->u1   = l2->u1;  
  l->hv   = l2->hv;  
  l->bn   = l2->bn;  
  l->incl = l2->incl;  
//
  incl    = l2->incl;
  deltav0 = inclf_desvx(incl,l2->u0) ;
  deltav1 = inclf_desvx(incl,l2->u1) ;
  l->v0    = l2->v00 - deltav0;
  l->v0    = l2->v10 - deltav1;
  // if ((l2->v10 + l2->v10) != (l2->v00 + l2->v11)) {
  //   printf ("error en line1de2\n");
  //   exit (3);
  //   }
}


// -------------------- --------------------

int tamgRaya (tpgen graya)
{
  int lu, lv;
  int pesl;
  tline line;
  line = (tpgen) graya;
  pesl = 8;                      // peso de la longitud frente a la anchura
  lu = line->u1 - line->u0 + 1;
  lv = line->v1 - line->v0 + 1;
  return lu * pesl + lv ;
}

tline mayorRaya (lista lineas)
{
  tnodol nodomay;
  nodomay = maximIEnlista (lineas, tamgRaya);
  return (tline) (nodomay->aitem);
}

void ordenadasRayas (lista *nlisneasOrd, lista lin)
{
  lista lineasOrd;
  lineasOrd = ordenadaLista (lin, tamgRaya);
  *nlisneasOrd = lineasOrd;
}

Boolean lrayaMenorQue (tpgen line, tpgen lmin)
{
  return (((tline)line)->u1 - ((tline)line)->u0 +1) < (int) lmin;
}

// -------------------- --------------------

void pruebaLine ()
{
  // tline s1, s2;
  // leeRaya (&s1); imprimeRaya (s1);
  lista segsLim, blin;
  leeRayas (&blin);
  imprimeRayas (blin);
  tomaLineasLim (&segsLim, blin, 40);
  imprimeRayas (segsLim);
  exit (0);
}

void pruebaLine2 ()
{
  tline s1;
  // tline s2;
  lista segsLim;
  // lista segsDer;
  leeRaya (&s1); imprimeRaya (s1);
  leeRayas (&segsLim);
  imprimeRayas (segsLim);
  printf ("area menor: %4d\n", areaMenorSegsIzqDer (s1, segsLim, 40) );
  exit (0);
}

lista cortesHorizontalesyVerticales (tvent vent)
{
  return 0L;
}


//************************ xxxxx **********************

void unionSegs (lista lineasAgr,
		lista lineas,   tnodol cg, tnodol fg )
{
  int sigder, usigder, sigiz; // siguiente derechea, ultimo id, siguiente izq
  tnodol nodol;
  tline line;
  int minr1 = -1 ;
  int maxm1 = 1000000 ;
  int seAvanza;
  usigder = minr1 ;
  while (TRUE) {
    sigiz = maxm1 ;
    // desde  cg  a  fg  inclusive
    for  (nodol = cg ;  ; nodol = nodol->siguiente) {
      line = (tline) nodol->aitem ;
      if ((line->u0 < sigiz) && (line->u0 > usigder)) {
        sigiz  = line->u0 ;
	sigder = line->u1 ;
        }
      if (nodol == fg) break ;
      }
    if (sigiz == maxm1) break ;
    seAvanza = TRUE ;
    while (seAvanza) {
      seAvanza = FALSE ;
      // desde  cg  a  fg  inclusive
      for  (nodol = cg ;  ; nodol = nodol->siguiente) {
        line = (tline) nodol->aitem ;
	if ((line->u0 <= (sigder + 1)) &&
	    (line->u0 >= sigiz) &&
	    (line->u1 > sigder)) {
	  sigder = line->u1 ;
	  seAvanza = TRUE ;
	  }
        if (nodol == fg) break ;
        }
      }
    // printf ("    %4d %4d\n", sigiz, sigder);
    anyadeRaya1 (lineasAgr,
		  sigiz,  ((tline)cg->aitem)->v0,
		  sigder, ((tline)fg->aitem)->v1) ;
    usigder = sigder ;
    }
}

void agrupaRayas (lista *nlineasAgr, lista lineas)
{
  lista lineasAgr;
  tnodol cg, fg;    // comienzo grupo y fin grupo
  tline line;
  tnodol nodol;
  lineasAgr = listaNueva ();
  if ( ! listaVacia (lineas) ) {
    cg = lineas->primero ;
    for (nodol = lineas->primero; nodol != 0L;nodol = nodol->siguiente) {
      line = (tline) nodol->aitem;
      if ((nodol->siguiente != 0L) &&
          ( ((tline)nodol->siguiente->aitem)->v0 - line->v1 >1) ){
        fg = nodol;
        // printf ("%4d %4d  %4d %4d\n", cg, fg, lineas[cg]->v0, lineas[fg]->v1);
        unionSegs (lineasAgr, lineas, cg, fg);
        cg = nodol->siguiente ;
        }
      }
    fg = lineas->ultimo;
    // printf ("%4d %4d  %4d %4d\n", cg, fg, lineas[cg]->v0, lineas[fg]->v1);
    unionSegs (lineasAgr, lineas, cg, fg);
    }
  *nlineasAgr = lineasAgr;
}

void anyadeLineaAgrupo (lista lineasAgr, tline line, int lmin)
{
  tnodol nodol;
  Boolean anyad ;
  anyad = FALSE ;
  if (! listaVacia(lineasAgr) )
    for (nodol = lineasAgr->primero; nodol != 0L; nodol = nodol->siguiente) {
      tline lineg;
      lineg = (tline) nodol->aitem;
      if (line->v0 == (lineg->v1 + 1)) {
        int u0n, u1n;
        u0n = max (line->u0, lineg->u0);
        u1n = min (line->u1, lineg->u1);
        if ((u1n - u0n + 1) >= lmin) {
          int area, arean;
          area  = (lineg->u1 - lineg->u0 + 1) * 
                  (lineg->v1 - lineg->v0 + 1) ;
          arean = (u1n       - u0n       + 1) * 
                  (lineg->v1 - lineg->v0 + 2) ;
          if (arean > area) {
	    lineg->u0 = u0n;
	    lineg->u1 = u1n;
	    lineg->v1 ++;
            anyad = TRUE ;
	    }
          }
        }
      }
  if (!anyad) 
     anyadeRaya (lineasAgr, copiaRaya(line));
}

void agrupaRayasB (lista *nlineasAgr, lista lineas, int lmin)
{
  lista lineasAgr;
  tline line;
  tnodol nodol;
  lineasAgr = listaNueva ();
  if ( ! listaVacia (lineas) ) {
    for (nodol = lineas->primero; nodol != 0L;nodol = nodol->siguiente) {
      line = (tline) nodol->aitem;
      anyadeLineaAgrupo (lineasAgr, line, lmin) ;
      }
    }
  *nlineasAgr = lineasAgr;
}

void anyadeLineaAgrupo0 (lista lineasAgr, tline line, int lmin)
{
  tnodol nodol;
  Boolean anyad ;
  anyad = FALSE ;
  if (! listaVacia(lineasAgr) )
    for (nodol = lineasAgr->primero; nodol != 0L; nodol = nodol->siguiente) {
      tline lineg;
      lineg = (tline) nodol->aitem;
      if (line->v0 == (lineg->v1 + 1)) {
        if ((line->u0 == lineg->u0) &&
          (line->u1 == lineg->u1) ) {
	  lineg->v1 ++;
          anyad = TRUE ;
          }
        }
      }
  if (!anyad) 
     anyadeRaya (lineasAgr, copiaRaya(line));
}

void agrupaRayasB0 (lista *nlineasAgr, lista lineas, int lmin)
{
  lista lineasAgr;
  tline line;
  tnodol nodol;
  lineasAgr = listaNueva ();
  if ( ! listaVacia (lineas) ) {
    for (nodol = lineas->primero; nodol != 0L;nodol = nodol->siguiente) {
      line = (tline) nodol->aitem;
      anyadeLineaAgrupo0 (lineasAgr, line, lmin) ;
      }
    }
  *nlineasAgr = lineasAgr;
}

//*********************** raya y ventana **********************

// anterior a 2009/03/15, sin inclinacion
/*
void sigueRayasHor1yV (lista lineas, tvent vent, int umbral, int y, int inclh)
{
  char ** pix;
  int x;
  int po, uo; // primer oscuro, ultimo ...
  int px, pxa; // pixel, pixel anterior
  // int lmin = 45;
  int lmin = 60;
  pix = vent->pix ;
  pxa = 255 ; // valor mayor de nivel de gris
  for (x=0; x<vent->tx; x++) {
    px = pix[y][x] & 0xFF ;
    if ((px < umbral) && (pxa >= umbral))
      po = x;
    if ((px >= umbral) && (pxa < umbral)) {
      uo = x - 1 ;
      if ((uo - po + 1) >= lmin) {
        anyadeRaya1 (lineas, po, y, uo, y) ;
        // printf (" %4d %4d %4d %4d\n", y, po, uo, uo - po +1);
      }
    }
    pxa = px;
    }
  if ((pxa < umbral)) {
    uo = vent->tx ;
    if ((uo - po + 1) >= lmin) {
      anyadeRaya1 (lineas, po, y, uo, y) ;
      // printf (" %4d %4d %4d %4d\n", y, po, uo, uo - po +1);
      }
    }
}
*/

void sigueRayasHor1y0 (lista lineas, tvent vent, int umbral, int y, int inclh, int lmin)
{
  char ** pix;
  int x;
  int yc;
  int tx; //, txd2;
  int po, uo; // primer oscuro, ultimo ...
  int px, pxa; // pixel, pixel anterior
  // int lmin = 70;   // 60
  pix = vent->pix ;
  tx = vent->tx ;
  // txd2 = tx / 2 ;
  pxa = 255 ; // valor mayor de nivel de gris
  for (x=0; x<tx; x++) {
    // yc = y + (x * inclh + txd2)/tx ;
    yc = y + (x * inclh )/INCLF_DIV ;
    px = pix[yc][x] & 0xFF ;
    if ((px < umbral) && (pxa >= umbral))
      po = x;
    if ((px >= umbral) && (pxa < umbral)) {
      uo = x - 1 ;
      if ((uo - po + 1) >= lmin) {
        anyadeRaya1 (lineas, po, y, uo, y) ;
        // printf (" %4d %4d %4d %4d\n", y, po, uo, uo - po +1);
        }
      }
    pxa = px;
    }
  if ((pxa < umbral)) {
    uo = vent->tx ;
    if ((uo - po + 1) >= lmin) {
      anyadeRaya1 (lineas, po, y, uo, y) ;
      // printf (" %4d %4d %4d %4d\n", y, po, uo, uo - po +1);
      }
    }
}

void sigueRayasHor1y (lista lineas, tvent vent, int umbral, int y, int inclh)
{
  int lmin = 70;   // 60
  sigueRayasHor1y0 (lineas, vent, umbral, y, inclh, lmin);
}

void sigueRayasVer1x0 (lista lineas, tvent vent, int umbral, int x, int inclv, int lmin)
{
  char ** pix;
  int y;
  int xc;
  int ty; // , tyd2;
  int po, uo; // primer oscuro, ultimo ...
  int px, pxa; // pixel, pixel anterior
  // int lmin = 30;   // 90
  pix = vent->pix ;
  ty = vent->ty ;
  // tyd2 = ty / 2 ;
  pxa = 255 ; // valor mayor de nivel de gris
  for (y=0; y<ty; y++) {
    // xc = x + (y * inclv + tyd2)/ty ;
    xc = x + (y * inclv )/INCLF_DIV ;
    px = pix[y][xc] & 0xFF ;
    if ((px < umbral) && (pxa >= umbral))
      po = y;
    if ((px >= umbral) && (pxa < umbral)) {
      uo = y - 1 ;
      if ((uo - po + 1) >= lmin) {
        anyadeRaya1 (lineas, po, x, uo, x) ;
        // printf (" %4d %4d %4d %4d\n", x, po, uo, uo - po +1);
        }
      }
    pxa = px;
    }
  if ((pxa < umbral)) {
    uo = vent->ty ;
    if ((uo - po + 1) >= lmin) {
      anyadeRaya1 (lineas, po, x, uo, x) ;
      // printf (" %4d %4d %4d %4d\n", x, po, uo, uo - po +1);
      }
    }
}

void sigueRayasVer1x (lista lineas, tvent vent, int umbral, int x, int inclv)
{
  int lmin = 30;   // 90, 30
  sigueRayasVer1x0 (lineas, vent, umbral, x, inclv, lmin);
}

void sigueRayasHorBlan1y (lista lineas, tvent vent, int umbral, int y, int lmin)
{
  char ** pix;
  int x;
  int po, uo; // primer oscuro, ultimo ...
  int px, pxa; // pixel, pixel anterior
  pix = vent->pix ;
    pxa = 0 ; /* valor menor de nivel de gris */
    for (x=0; x<vent->tx; x++) {
      px = pix[y][x] & 0xFF ;
      if ((px >= umbral) && (pxa < umbral))
        po = x;
      if ((px < umbral) && (pxa >= umbral)) {
        uo = x - 1 ;
        if ((uo - po + 1) >= lmin) {
          anyadeRaya1 (lineas, po, y, uo, y) ;
          // printf (" %4d %4d %4d %4d\n", y, po, uo, uo - po +1);
        }
      }
      pxa = px;
      }
    if ((pxa >= umbral)) {
      uo = vent->tx - 1;
      if ((uo - po + 1) >= lmin) {
        anyadeRaya1 (lineas, po, y, uo, y) ;
        // printf (" %4d %4d %4d %4d\n", y, po, uo, uo - po +1);
        }
      }
}

void sigueRayasVerBlan1x (lista lineas, tvent vent, int umbral, int x, int lmin, int inclv)
{
  char ** pix;
  int y;
  int xc;
  int ty; //, tyd2;
  int po, uo; // primer oscuro, ultimo ...
  int px, pxa; // pixel, pixel anterior
  pix = vent->pix ;
  ty = vent->ty ;
  // tyd2 = ty / 2 ;
  pxa = 0 ; // valor menor de nivel de gris
  for (y=0; y<ty; y++) {
    // xc = x + (y * inclv + tyd2)/ty ;
    xc = x + (y * inclv )/INCLF_DIV ;
    px = pix[y][xc] & 0xFF ;
    if ((px >= umbral) && (pxa < umbral))
      po = y;
    if ((px < umbral) && (pxa >= umbral)) {
      uo = y - 1 ;
      if ((uo - po + 1) >= lmin) {
        anyadeRaya1 (lineas, po, x, uo, x) ;
        // printf (" %4d %4d %4d %4d\n", x, po, uo, uo - po +1);
        }
      }
    pxa = px;
    }
  if ((pxa >= umbral)) {
    uo = vent->ty - 1 ;
    if ((uo - po + 1) >= lmin) {
      anyadeRaya1 (lineas, po, x, uo, x) ;
      // printf (" %4d %4d %4d %4d\n", x, po, uo, uo - po +1);
      }
    }
}

//************************ ----- **********************/

//  aceptara dos cortes pequeños muy cercanos,
//  esto no lo acepta
void uneLineasProximas (lista lineas, int dist)
{
  tnodol nodol;
  tline l1, l2;
  if (longLista (lineas) <= 1)
    return;
  // recorre lista: una linea y su siguiente
  for (nodol = lineas->primero; nodol->siguiente != 0L;){
    l1 = (tline) nodol->aitem;
    l2 = (tline) nodol->siguiente->aitem;
    // if (max(v0s) <= min(v1s)) and (u0-u1-1 <= dist)
    if ((max(l1->v0,l2->v0) <= min(l1->v1,l2->v1)) &&
        ((l2->u0 - l1->u1 -1) <= dist) ){
      // une 2 lineas
      l1->v0 = (l1->v0 + l2->v0 + 1)/2;
      l1->v1 = (l1->v1 + l2->v1 + 1)/2;
      // l1->u0  igual
      l1->u1 = l2->u1;
      eliminaNdelista (lineas, nodol->siguiente);
      }
    else
      nodol = nodol->siguiente;
    }
}

//************************ sigue **********************/

void sigueRayasHor (lista *nlineas, tvent vent, int umbral, int inclh)
{
  lista lineas;
  int y;
  int yi, yf;
  lineas = listaNueva ();
  pon_vprim_vult (inclh, vent->tx, vent->ty, &yi, &yf);
  for(y=yi; y<yf; y++) {
    sigueRayasHor1y (lineas, vent, umbral, y, inclh) ;
    }
  *nlineas = lineas;
}

void siguePunteadasHor (lista *nlineas, tvent vent, int umbral, int inclh, int dist, int lmin)
{
  lista lineas;
  int y;
  int yi, yf;
  lineas = listaNueva ();
  pon_vprim_vult (inclh, vent->tx, vent->ty, &yi, &yf);
  for(y=yi; y<yf; y++) {
    sigueRayasHor1y0 (lineas, vent, umbral, y, inclh, 1) ;
    }
  uneLineasProximas (lineas, dist);
  eliminaDeListaSiFuncEResul (lineas, (tpgen) lmin, lrayaMenorQue, TRUE);
  *nlineas = lineas;
}

void sigueRayasVer (lista *nlineas, tvent vent, int umbral, int inclv)
{
  lista lineas;
  int x;
  int xi, xf;
  lineas = listaNueva ();
  pon_vprim_vult (inclv, vent->ty, vent->tx, &xi, &xf);
  // printf("inclv:%4d, vent->tx: %4d, xi:%4d, xf: %4d\n",  inclv, vent->tx, xi, xf);    //
  for(x=xi; x<xf; x++) {
    sigueRayasVer1x (lineas, vent, umbral, x, inclv) ;
    }
  *nlineas = lineas;
}

void siguePunteadasVer (lista *nlineas, tvent vent, int umbral, int inclv, int dist, int lmin)
{
  lista lineas;
  int x;
  int xi, xf;
  lineas = listaNueva ();
  pon_vprim_vult (inclv, vent->ty, vent->tx, &xi, &xf);
  // printf("inclv:%4d, vent->tx: %4d, xi:%4d, xf: %4d\n",  inclv, vent->tx, xi, xf);    //
  for(x=xi; x<xf; x++) {
    sigueRayasVer1x0 (lineas, vent, umbral, x, inclv, 1) ;
    }
  uneLineasProximas (lineas, dist);
  eliminaDeListaSiFuncEResul (lineas, (tpgen) lmin, lrayaMenorQue, TRUE);
  *nlineas = lineas;
}

void sigueRayasHorBlan (lista *nlineas, tvent vent, int umbral, int lmin)
{
  lista lineas;
  int y;
  lineas = listaNueva ();
  for(y=0; y<vent->ty; y++) {
    sigueRayasHorBlan1y (lineas, vent, umbral, y, lmin) ;
    }
  *nlineas = lineas;
}

void sigueRayasHorBlanLat (lista *nlineas, tvent vent, int umbral, int lmin, int nlat)
{
  lista lineas;
  int y;
  int yi, yf;
  lineas = listaNueva ();
  yi = 0; yf = vent->ty-1;
  if (nlat > 0) 
    yf = yi + nlat;
  else
    yi = yf + nlat;
  for(y=yi; y<=yf; y++) {
    sigueRayasHorBlan1y (lineas, vent, umbral, y, lmin) ;
    }
  *nlineas = lineas;
}

void sigueRayasVerBlanIncl (lista *nlineas, tvent vent, int umbral, int lmin, int inclv)
{
  lista lineas;
  int x;
  int xi, xf;
  lineas = listaNueva ();
  pon_vprim_vult (inclv, vent->ty, vent->tx, &xi, &xf);
  // printf("inclv:%4d, vent->tx: %4d, xi:%4d, xf: %4d\n",  inclv, vent->tx, xi, xf);    //
  for(x=xi; x<xf; x++) {
    sigueRayasVerBlan1x (lineas, vent, umbral, x, lmin, inclv) ;
    }
  *nlineas = lineas;
}

void sigueRayasVerBlanInclLat (lista *nlineas, tvent vent,
                               int umbral, int lmin, int inclv, int nlat)
{
  lista lineas;
  int x;
  int xi, xf;
  lineas = listaNueva ();
  pon_vprim_vult (inclv, vent->ty, vent->tx, &xi, &xf);
  if (nlat > 0) 
    xf = xi + nlat;
  else
    xi = xf + nlat;
  // printf("inclv:%4d, vent->tx: %4d, xi:%4d, xf: %4d\n",  inclv, vent->tx, xi, xf);    //
  for(x=xi; x<xf; x++) {
    sigueRayasVerBlan1x (lineas, vent, umbral, x, lmin, inclv) ;
    }
  *nlineas = lineas;
}

void sigueRayasVerBlanLar (lista *nlineas, tvent vent, int umbral)
{
  int inclv;
  inclv = calculaInclinacionV(vent);
  // printf("inclv:%4d\n", inclv);
  sigueRayasVerBlanIncl (nlineas, vent, umbral, vent->ty - 5, inclv); 
}

//*********************** sigueyAgrupa **********************

void sigueyAgrupaRayasHor (lista *nlineasAgr, tvent vent)
{
  int umbral ;
  int inclh;
  lista lineas;
  umbral = umbralDeVent (vent, 40);   // porcNeg 62, 45, 35
  inclh = calculaInclinacionH(vent);
  sigueRayasHor (&lineas, vent, umbral, inclh);
  // imprimeRayas (lineas);
  agrupaRayas (nlineasAgr, lineas);
  // imprimeRayas (*nlineasAgr);
  ponInclinacionEnRayas (*nlineasAgr, inclh);
  ponTipohvEnRayas (*nlineasAgr, 'h');
  liberaItemsNodosYlista (lineas);
}

void sigueyAgrupaPunteadasHor (lista *nlineasAgr, tvent vent, int dist, int lmin)
{
  int umbral ;
  int inclh;
  lista lineas;
  umbral = umbralDeVent (vent, 28);   // porcNeg 32, 62, 45, 35
  inclh = calculaInclinacionH(vent);
  siguePunteadasHor (&lineas, vent, umbral, inclh, dist, lmin);
  // imprimeRayas (lineas);
  agrupaRayas (nlineasAgr, lineas);
  // imprimeRayas (*nlineasAgr);
  ponInclinacionEnRayas (*nlineasAgr, inclh);
  ponTipohvEnRayas (*nlineasAgr, 'h');
  liberaItemsNodosYlista (lineas);
}

void sigueyAgrupaRayasVer (lista *nlineasAgr, tvent vent)
{
  int umbral ;
  int inclv;
  lista lineas;
  umbral = umbralDeVent2 (vent, 30);  // porcNeg  45, 35
  // printf ("line: sigueyAgrupaRayasVer, umbral %3d\n", umbral);
  inclv = calculaInclinacionV(vent);
  sigueRayasVer (&lineas, vent, umbral, inclv);
  // imprimeRayas (lineas);
  agrupaRayas (nlineasAgr, lineas);
  ponInclinacionEnRayas (*nlineasAgr, inclv);
  ponTipohvEnRayas (*nlineasAgr, 'v');
  liberaItemsNodosYlista (lineas);
}

void sigueyAgrupaPunteadasVer (lista *nlineasAgr, tvent vent, int dist, int lmin)
{
  int umbral ;
  int inclv;
  lista lineas;
  umbral = umbralDeVent2 (vent, 41);  // porcNeg  45, 35
  // printf ("line: sigueyAgrupaRayasVer, umbral %3d\n", umbral);
  inclv = calculaInclinacionV(vent);
  siguePunteadasVer (&lineas, vent, umbral, inclv, dist, lmin);
  // imprimeRayas (lineas);
  agrupaRayas (nlineasAgr, lineas);
  ponInclinacionEnRayas (*nlineasAgr, inclv);
  ponTipohvEnRayas (*nlineasAgr, 'v');
  liberaItemsNodosYlista (lineas);
}

void sigueyAgrupaRayasHorBlan (lista *nlineasAgr, tvent vent, int lmin)
{
  int umbral ;
  lista lineas;
  umbral  = umbralDeVent (vent, 48);   // 48 porcNeg, 75
  sigueRayasHorBlan (&lineas, vent, umbral, lmin);
  agrupaRayasB (nlineasAgr, lineas, lmin);
  liberaItemsNodosYlista (lineas);
}

void sigueyAgrupaRayasHorBlanLar (lista *nlineasAgr, tvent vent)
{
      // ?, o toda? casi toda la ventana
  sigueyAgrupaRayasHorBlan (nlineasAgr, vent, vent->tx - 5);
}

void sigueyAgrupaRayasVerBlanLar (lista *nlineasAgr, tvent vent)
{
  int umbral ;
  lista lineas;
  umbral  = umbralDeVent (vent, 40);  // porcNeg  70, 55
  sigueRayasVerBlanLar (&lineas, vent, umbral);
  agrupaRayas (nlineasAgr, lineas);
  liberaItemsNodosYlista (lineas);
}

void sigueyAgrupaRayasVerBlanIncl (lista *nlineasAgr, tvent vent, int lmin, int incl)
{
  int umbral ;
  lista lineas;
  umbral  = umbralDeVent (vent, 40);  // porcNeg  55, 90
  // printf ("umbral: %3d\n", umbral);
  sigueRayasVerBlanIncl (&lineas, vent, umbral, lmin, incl);
  agrupaRayasB (nlineasAgr, lineas, lmin);
  liberaItemsNodosYlista (lineas);
}

void sigueyAgrupa0RayasVerBlanIncl (lista *nlineasAgr, tvent vent, int lmin, int incl)
{
  int umbral ;
  lista lineas;
  umbral  = umbralDeVent (vent, 55);  // porcNeg  55
  // printf ("umbral: %3d\n", umbral);
  sigueRayasVerBlanIncl (&lineas, vent, umbral, lmin, incl);
  agrupaRayasB0 (nlineasAgr, lineas, lmin);
  liberaItemsNodosYlista (lineas);
}

void sigueyAgrupaRayasVerBlanLarIncl (lista *nlineasAgr, tvent vent, int incl)
{
  sigueyAgrupaRayasVerBlanIncl (nlineasAgr, vent, vent->ty - 5, incl);
}

// -------------------- sumas cuadrados de noes_consc --------------------

//                                     p. parcelar ???
// sums_lintr2_en_blan_vert (int *sl2, tvent vent)

//                                     p. sudokus
// sums_lintr2_en_negr_vert ()
// sums_lintr2_en_negr_horz ()

//                                     p. parcelado irregular_1
//                blan_vert
//                blan_horz

// -------------------- pinta alrd. raya --------------------

void pintaAlrededorRaya (tline line, tvent vent, int n)
{
  int desvV;
  desvV = inclf_desvx(line->incl,line->u0);
  if (line->hv == 'h') {
    pintaRihn (vent, max(0, line->v0+desvV-1), line->incl, line->u0, line->u1, n);
    pintaRihn (vent, min(vent->ty-1,line->v1+desvV+1), line->incl, line->u0, line->u1, n);
    }
  else {  //  line->hv == 'v'
    pintaRivn (vent, max(0, line->v0+desvV-1), line->incl, line->u0, line->u1, n);
    pintaRivn (vent, min(vent->tx-1,line->v1+desvV+1), line->incl, line->u0, line->u1, n);
    }
}

void pintaAlrededorRayaN (lista lineas, int pos, tvent vent, int n)
{
  tnodol nl;
  tline l;
  if (longLista(lineas) >= pos) {
    nl = enesimoNodoDeLista(lineas, pos);
    l = (tline) (nl->aitem);
    pintaAlrededorRaya (l, vent, n);
    }
}

void pintaAlrededorRayas (lista lineas, tvent vent, int n)
{
 tnodol nodol;
 for (nodol=lineas->primero; nodol != 0L; nodol=nodol->siguiente)
   pintaAlrededorRaya ((tline) nodol->aitem, vent, n);
}

void nlineasMasLargas2 (lista *lineasLargas, lista lineasagr, int nmax, Boolean crec)
{
 lista largas;
 int n;
 tnodol nodol, nodoli;
 int l, li;
 largas = listaNueva ();
 n = 0;
 if (lineasagr->primero != 0L) {
   aniadeafinlista (largas, lineasagr->primero->aitem);
   for (nodol = lineasagr->primero->siguiente; nodol != 0L; nodol = nodol->siguiente) {
     l = ((tline)nodol->aitem)->u1 - ((tline)(nodol->aitem))->u0;
     if (l > ((tline)largas->ultimo->aitem)->u1 -
             ((tline)largas->ultimo->aitem)->u0 ) {
       for (nodoli = largas->primero; nodoli != 0L; nodoli = nodoli->siguiente) {
         li = ((tline)nodoli->aitem)->u1 - ((tline)nodoli->aitem)->u0;
//         if (li <= l)
         if ((li<l) || ((li=l) && !crec))
           break;
         }
         aniadealistaAntes (largas, nodol->aitem, nodoli);
         if (n < nmax)
           n ++;
         else
           eliminaNdelista (largas, largas->ultimo);
       }
     else if (n < nmax) {
       aniadeafinlista (largas, nodol->aitem);
       n ++;
       }
     }
   }
 *lineasLargas = largas;
}

//*********************** sigue ventana **********************

void sigueRayas (tvent vent)
{
//  lista lineasVagr ;
//  lista lineasVblanAgr ;
//  lista lineasHagr ;
  lista lineasHblanAgr ;
//  int inclv;
/** /
  sigueyAgrupaRayasHor (&lineasHagr, vent);
  printf ("rayas n. horizonatales\n");
  imprimeRayas (lineasHagr);
/ ** /
  sigueyAgrupaRayasVer (&lineasVagr, vent);
  printf ("rayas n. verticales\n");
  imprimeRayas (lineasVagr);
/ **/
  sigueyAgrupaRayasHorBlan (&lineasHblanAgr, vent, vent->tx / 8);
  printf ("rayas blancas horizonatales\n");
  imprimeRayas (lineasHblanAgr);
/** /
  inclv = calculaInclinacionV(vent);
  printf("inclv:%4d\n", inclv);
  sigueyAgrupaRayasVerBlanIncl (&lineasVblanAgr, vent, vent->ty * 4 / 5, inclv);
  printf ("rayas blancas verticales\n");
  imprimeRayas (lineasVblanAgr);
/ **/
}

void sigueRayasN (tvent vent, int n)
{
  int i;
  timagf imagr[5];
  tvent ventr;
  timagf imageh, imagev;
  int nestr;
  tvent venteh, ventev;
  lista lineas;
  lista lineasHagr, lineasHagrLar ;
  lista lineasVagr, lineasVagrLar ;
  lista lineasVblanAgr, lineasVblanAgrLarO, lineasVblanAgrLarE;
  lista lineasHblanAgr, lineasHblanAgrLarN, lineasHblanAgrLarS;
  int umbral;
  int inclv;
  int delx, dely;
//
  imagr[0] = vent->imaBase;
  for (i=1; i<5; i++)
    creaImagenReducida ( &imagr[i], imagr[i-1]);
  ventr = imagr[2]->ven0;
  nestr = 4;
  creaImagenMaxsReducidaDeVentana(&imageh, vent, nestr, 1);
  creaImagenMaxsReducidaDeVentana(&imagev, vent, 1, nestr);
  venteh = imageh->ven0;
  ventev = imagev->ven0;
//
  sigueyAgrupaRayasHor (&lineasHagr, venteh);
  nlineasMasLargas (&lineasHagrLar, lineasHagr, n);
  imprimeRayasCab (lineasHagrLar, "rayas n. horizonatales");
//
  sigueyAgrupaRayasVer (&lineasVagr, ventev);
  nlineasMasLargas (&lineasVagrLar, lineasVagr, n);
  imprimeRayasCab (lineasVagrLar, "\nrayas n. verticales");
/*
  sigueyAgrupaRayasHorBlan (&lineasHblanAgr, vent, vent->tx / 8);
  nlineasMasLargas (&lineasHblanAgrLar, lineasHblanAgr, n);
  imprimeRayasCab (lineasHblanAgrLar, "\nrayas blancas horizonatales");
*/
//  blancas
  umbral = umbralDeVent (ventr, 70);
  delx = ventr->tx / 6;
  dely = ventr->ty / 6;
//  horizontal
  sigueRayasHorBlanLat (&lineas, ventr, umbral, ventr->tx*3/5, delx);
  ponTipohvEnRayas (lineas, 'h');
  agrupaRayasB0 (&lineasHblanAgr, lineas, ventr->tx*3/5);
  liberaItemsNodosYlista (lineas);
  nlineasMasLargas2 (&lineasHblanAgrLarN, lineasHblanAgr, n, TRUE);
  imprimeRayasCab (lineasHblanAgrLarN, "\nrayas blancas horizonatales norte");
//
  sigueRayasHorBlanLat (&lineas, ventr, umbral, ventr->tx*3/5, -delx);
  ponTipohvEnRayas (lineas, 'h');
  agrupaRayasB0 (&lineasHblanAgr, lineas, ventr->tx*3/5);
  liberaItemsNodosYlista (lineas);
  nlineasMasLargas (&lineasHblanAgrLarS, lineasHblanAgr, n);
  imprimeRayasCab (lineasHblanAgrLarS, "\nrayas blancas horizonatales sur");
//  vertical
  inclv = calculaInclinacionV(ventr);
  // printf("inclv:%4d\n", inclv);
//
  sigueRayasVerBlanInclLat (&lineas, ventr, umbral, ventr->ty*3/5,inclv, dely);
  ponTipohvEnRayas (lineas, 'v');
  agrupaRayasB0 (&lineasVblanAgr, lineas, ventr->ty*3/5);
  liberaItemsNodosYlista (lineas);
  nlineasMasLargas2 (&lineasVblanAgrLarO, lineasVblanAgr, n, TRUE);
  imprimeRayasCab (lineasVblanAgrLarO, "\nrayas blancas verticales oeste");
//
  sigueRayasVerBlanInclLat (&lineas, ventr, umbral, ventr->ty*3/5,inclv, -dely);
  ponTipohvEnRayas (lineas, 'v');
  agrupaRayasB0 (&lineasVblanAgr, lineas, ventr->ty*3/5);
  liberaItemsNodosYlista (lineas);
  nlineasMasLargas (&lineasVblanAgrLarE, lineasVblanAgr, n);
  imprimeRayasCab (lineasVblanAgrLarE, "\nrayas blancas verticales este");
//
  pintaAlrededorRayaN (lineasHblanAgrLarN, 1, ventr, 1);
  pintaAlrededorRayaN (lineasHblanAgrLarS, 1, ventr, 2);
  pintaAlrededorRayaN (lineasVblanAgrLarO, 1, ventr, 3);
  pintaAlrededorRayaN (lineasVblanAgrLarE, 1, ventr, 4);
//
  escribeVentana (imagr[2]->ven0, "sal/pr-line-0xa.pgm");
/**/
}

void sigueRayasBlanLar (tvent vent)
{
  lista lineasHblanAgr ;
  lista lineasVblanAgr ;
  //
  sigueyAgrupaRayasHorBlanLar (&lineasHblanAgr, vent);
  imprimeRayas (lineasHblanAgr);
  //
  sigueyAgrupaRayasVerBlanLar (&lineasVblanAgr, vent);
  imprimeRayas (lineasVblanAgr);
}

int sumaAnchoRayasBlanLarIncl (tvent vent, int incl256)
{
  int sumaAncho;
  lista lineasVblanAgr ;
  int inclven;
  inclven = (vent->ty * incl256 - 128 ) / 256;
  sigueyAgrupaRayasVerBlanLarIncl (&lineasVblanAgr, vent, inclven);
  sumaAncho = sumaAnchoRayas (lineasVblanAgr) + abs (inclven);
  liberaItemsNodosYlista (lineasVblanAgr);
  return sumaAncho;
}

//************************ posicion en ventana **********************

void posicionLineaCabecera (tline *nlinea, tvent vent)
{
  lista lineasHagr ;
  tnodol nodol;
  tline line;
  sigueyAgrupaRayasHor (&lineasHagr, vent);
  // imprimeRayas (lineasHagr);
  for (nodol = lineasHagr->primero; nodol != 0L;nodol = nodol->siguiente) {
    line  = (tline) nodol->aitem ;
    if ((line->u1 - line->u0) >= ((vent->tx * 65)/100) )
      break ;
    }
  *nlinea = copiaRaya (line);
}

void posicionMargenColumnas (tline *nlinea, tvent vent)
{
  lista lineasVblanAgr ;
  tnodol nodol;
  tline line;
  int centroLinea;
  sigueyAgrupaRayasVerBlanLar (&lineasVblanAgr, vent);
  // imprimeRayas (lineasVblanAgr);
  for (nodol = lineasVblanAgr->primero; nodol != 0L;nodol = nodol->siguiente) {
    line  = (tline) nodol->aitem ;
    centroLinea = (line->v1 + line->v0) / 2;
    if ( ((line->v1 - line->v0) >= 12 )     &&
         (centroLinea >=  (vent->tx / 3))   &&
         (centroLinea <= ((vent->tx * 2) / 3)) )
      break ;
    }
  *nlinea = copiaRaya (line);
}

void posicionMargenesSeccion (tline *nlinea, tvent vent)
{
  lista lineasHblanAgr ;
  tnodol nodol;
  tline line;
  sigueyAgrupaRayasHorBlanLar (&lineasHblanAgr, vent);
  // imprimeRayas (lineasHblanAgr);
  for (nodol = lineasHblanAgr->primero; nodol != 0L;nodol = nodol->siguiente) {
    line  = (tline) nodol->aitem ;
    if ( ((line->v1 - line->v0) >= 30 )     &&
         ( line->v0 > 20              ) )
      break ;
    }
  *nlinea = copiaRaya (line);
}

void posicionesMargenesSeccion (lista *nlineas, tvent vent)
{
  lista lineasMargen ;
  lista lineasHblanAgr ;
  tnodol nodol;
  tline line;
  lineasMargen = listaNueva ();
  sigueyAgrupaRayasHorBlanLar (&lineasHblanAgr, vent);
  // imprimeRayas (lineasHblanAgr);
  for (nodol = lineasHblanAgr->primero; nodol != 0L;nodol = nodol->siguiente) {
    line  = (tline) nodol->aitem ;
    if ( ((line->v1 - line->v0) >= 30 )     &&
         ( line->v0 > 20              )     &&
         ((vent->ty - line->v1) > 20  ) )
      anyadeRaya (lineasMargen, copiaRaya (line));
    }
  *nlineas = lineasMargen ;
}

void posicionMargenesMinipage (tline *nlinea, tvent vent)
{
  lista lineasVblanAgr ;
  tnodol nodol;
  tline line;
  sigueyAgrupaRayasVerBlanLar (&lineasVblanAgr, vent);
  // imprimeRayas (lineasVblanAgr);
  for (nodol = lineasVblanAgr->primero; nodol != 0L;nodol = nodol->siguiente) {
    line  = (tline) nodol->aitem ;
    if ( ((line->v1 - line->v0) >= 12 )     &&
         ( line->v0 > 12 )              )
      break ;
    }
  *nlinea = copiaRaya (line);
}

Boolean separadoMargen (int linev0, int  linev1,int  venttm,int  inclv,int  margen)
{
  int lant, lpos;
  lant = 0; lpos = venttm;
  if (inclv >= 0)
    lpos = venttm - inclv ;
  else 
    lant = - inclv ;
  return  ((linev1 - linev0) >= margen ) &&
          ((linev0 - lant)   >= margen ) &&
          ((lpos   - linev1) >= margen )   ;
}

void posicionesMargenesMinipage (lista *nlineas, tvent vent)
{
  lista lineasMargen ;
  lista lineasVblanAgr ;
  tnodol nodol;
  tline line;
  int inclv;
  inclv = calculaInclinacionV(vent);
  lineasMargen = listaNueva ();
  sigueyAgrupaRayasVerBlanLar (&lineasVblanAgr, vent);
  imprimeRayas (lineasVblanAgr);
  //
  for (nodol = lineasVblanAgr->primero; nodol != 0L;nodol = nodol->siguiente) {
    line  = (tline) nodol->aitem ;
    if ( separadoMargen(line->v0, line->v1, vent->tx, inclv, 12) )
      anyadeRaya (lineasMargen, copiaRaya (line));
    }
  *nlineas = lineasMargen ;
} 
 
// --------------------

Boolean seCortan (tline l1, tline l2)
{
  struct tecuadrltr cuad;
  int x0, x1, y0, y1;
  if ( ( l1->hv == 'h' && l2->hv == 'h') ||
       ( l2->hv == 'v' && l1->hv == 'v') )
    return FALSE ;
  // actuamos como si l1 horizontal y l2 vertical
  //   si somos coherentes da lo mismo (simetria)
  pon_paralogr (l1->incl, l1->v0, l1->v1, l2->incl, l2->v0, l2->v1,
                  & cuad);
  // printf ("%4d %4d %4d %4d %4d %4d %4d %4d \n",
  //          xno,yno,xne,yne,xse,yse,xno,yno);
/*
  x0 = min(cuad.xno, cuad.xso);
  x1 = max(cuad.xne, cuad.xse);
  y0 = min(cuad.yne, cuad.yno);
  y1 = max(cuad.yse, cuad.yso);
*/
  x0 = cuad.x0;
  x1 = cuad.x1;
  y0 = cuad.y0;
  y1 = cuad.y1;
  // printf ("%4d %4d %4d %4d %4d %4d %4d %4d \n",
  //          x0,y0,x1,y1,l1->u0,l1->u0,l2->u0,l2->u1);
  return ( max (l1->u0, x0)  <=
           min (l1->u1, x1) ) &&
         ( max (l2->u0, y0)  <=
           min (l2->u1, y1) )  ;
}

Boolean seCortan_rg (tpgen l1, tpgen l2)
{
//  if (( ((tline)l1)->u0 == 192) || ( ((tline)l2)->u0 == 192)) {
//    printf (" -------------===> ");
//    if (seCortan ((tline) l1, (tline) l2))
//      printf ("si ");
//    else
//      printf ("no ");
//    imprimeRaya (l1);
//    }
  return seCortan ((tline) l1, (tline) l2);
}

// devuelve en *ngrupos  lista de grupos (H y V) de lineas que se cortan.
void agrupaLineasQueSeCortan (lista *ngrupos,
                              lista lineasH, lista lineasV)
{
  tnodol nodol;
  lista lineasT, lineasv2, gruposLin;
  for (nodol=lineasH->primero; nodol !=0L; nodol = nodol->siguiente)
    ((tline) nodol->aitem ) ->hv = 'h';
  for (nodol=lineasV->primero; nodol !=0L; nodol = nodol->siguiente)
    ((tline) nodol->aitem ) ->hv = 'v';
  lineasT  = copiaLista (lineasH);
  lineasv2 = copiaLista (lineasV);
  pasalistaafinlista (lineasT, lineasv2);
  free (lineasv2);
  gruposLin =  cierreTransitivo (lineasT, seCortan_rg);
  // recorreListaAplicando (gruposLin, imprimeRayas);          //
  *ngrupos = gruposLin;
}

void aniadeordenado (lista nl, tline linea)
{
  tnodol nodol;
  tline lineai;
  for (nodol = nl->primero; nodol!=0L; nodol=nodol->siguiente){
    lineai = (tline) nodol->aitem;
    if (   (linea->v1 < lineai->v0) ||
         ( ( max(linea->v0,lineai->v0) <= min(linea->v1,lineai->v1) ) &&
           (linea->u1 < lineai->u0) ) ) {
      aniadealistaAntes (nl, (tpgen) linea, nodol);
      return ;
      }
    }
  aniadeafinlista (nl, (tpgen) linea);
}

lista lineasdeOrientacion (lista l, char c)
{
  lista nl;
  tnodol nodol;
  tline linea;
  nl = listaNueva ();
  for (nodol = l->primero; nodol!=0L; nodol=nodol->siguiente){
    linea = (tline) nodol->aitem; 
    if ( linea->hv == c ) {
      // aniadeafinlista (nl, (tpgen)linea); // no, que la salida queda a veces desordenada
      aniadeordenado (nl, linea);
      }
    }
  return nl;
}

void junta2NodosLineasContinuas (tnodol nodol, tnodol nodol2, lista l)
{
  tline lin1, lin2, lin1n;
  // int w10, w11, w20, w21;
  int w10, w20;
  int tv1;
         // hay que copiar el item lin1
  lin1 = (tline) nodol->aitem;
  lin2 = (tline) nodol2->aitem;
  // imprimeRaya (lin1);
  // imprimeRaya (lin2);
  lin1n = copiaRaya (lin1);
  tv1 = lin1->v1 - lin1->v0;
  w10 = lin1->v0 + (lin1->u0 * lin1->incl + 32768) / 65576;
  // w11 = lin1->v1 + (lin1->u0 * lin1->incl + 32768) / 65576;
  w20 = lin2->v0 + (lin2->u1 * lin2->incl + 32768) / 65576;
  // w21 = lin2->v1 + (lin2->u1 * lin2->incl + 32768) / 65576;
  //
  lin1n->incl = ((w20-w10) * 65576) / (lin2->u1 - lin1->u0) ;
  lin1n->u1   = lin2->u1;
  lin1n->v0   = w10 - (lin1->u0 * lin1->incl + 32768) / 65576;
  lin1n->v1   = lin1->v0 + tv1;
  // imprimeRaya (lin1n);
  //
  nodol->aitem = lin1n;
  eliminaNdelista (l, nodol2);
}

//                     2013 03 04
void agrupaLineasContinuas (lista *nlineasc, lista lineas, int margen_u, int margen_v)
{
  lista nl;
  tnodol nodol, nodol2;
  // tline linea;
  tline lin1, lin2;
  int seavanza;
  int w10, w11, w20, w21;
  nl = copiaLista (lineas);         // sin profundidad, no copia items
  for (seavanza=TRUE; seavanza;){
    seavanza = FALSE;
    for (nodol = nl->primero;
        (nodol!=0L) && (nodol->siguiente!=0L) && !seavanza ;
         nodol=nodol->siguiente){
      for (nodol2 = nodol->siguiente; nodol2!=0L; nodol2=nodol2->siguiente){
        lin1 = (tline) nodol->aitem;
        lin2 = (tline) nodol2->aitem;
        if ( lin2->u0 > (lin1->u1 + margen_u) )
          break;
        w10 = lin1->v0 + (lin1->u1 * lin1->incl + 32768) / 65576;
        w11 = lin1->v1 + (lin1->u1 * lin1->incl + 32768) / 65576;
        w20 = lin2->v0 + (lin2->u0 * lin2->incl + 32768) / 65576;
        w21 = lin2->v1 + (lin2->u0 * lin2->incl + 32768) / 65576;
        if ( abs((w10+w11)-(w20+w21)) <= (2 * margen_v) ) {
          junta2NodosLineasContinuas (nodol, nodol2, nl);
          seavanza = TRUE;
          break;
          }
        }
      }
    }
  *nlineasc = nl;
}

int nlineasMasLargas (lista *lineasLargas, lista lineasagr, int nmax)
{
 lista largas;
 int n;
 tnodol nodol, nodoli;
 int l, li;
 largas = listaNueva ();
 n = 0;
 if (lineasagr->primero != 0L) {
   aniadeafinlista (largas, lineasagr->primero->aitem);
   for (nodol = lineasagr->primero->siguiente; nodol != 0L; nodol = nodol->siguiente) {
     l = ((tline)nodol->aitem)->u1 - ((tline)(nodol->aitem))->u0;
     if (l > ((tline)largas->ultimo->aitem)->u1 -
             ((tline)largas->ultimo->aitem)->u0 ) {
       for (nodoli = largas->primero; nodoli != 0L; nodoli = nodoli->siguiente) {
         li = ((tline)nodoli->aitem)->u1 - ((tline)nodoli->aitem)->u0;
         if (li <= l)
           break;
         }
         aniadealistaAntes (largas, nodol->aitem, nodoli);
         if (n < nmax)
           n ++;
         else
           eliminaNdelista (largas, largas->ultimo);
       }
     else if (n < nmax) {
       aniadeafinlista (largas, nodol->aitem);
       n ++;
       }
     }
   }
 *lineasLargas = largas;
 return n;
}

void ordenaPor_vx (lista *lineasLargasOv, lista lineasLargas)
{
 lista largas;
 tnodol nodol, nodoli;
 int v, vi;
 largas = listaNueva ();
 if (longLista(lineasLargas) != 0)
   aniadeafinlista (largas, lineasLargas->primero->aitem);
 for (nodol = lineasLargas->primero->siguiente; nodol != 0L; nodol = nodol->siguiente) {
   v = ((tline)nodol->aitem)->v0 ;
   if (v > ((tline)largas->ultimo->aitem)->v0 ) {
     for (nodoli = largas->primero; nodoli != 0L; nodoli = nodoli->siguiente) {
       vi = ((tline)nodoli->aitem)->v0;
       if (vi <= v)
         break;
       }
       aniadealistaAntes (largas, nodol->aitem, nodoli);
     }
   else
     aniadeafinlista (largas, nodol->aitem);
   }
 *lineasLargasOv = largas;
}

Boolean seCortan2 (tline l1, tline l2)
{
  return ( max (l1->u0, l2->v0)  <=
           min (l1->u1, l2->v1) ) &&
         ( max (l2->u0, l1->v0)  <=
           min (l2->u1, l1->v1) ) ;
}


void eliminadasLineasCortadas (lista * lineasVsc, lista lineasV, lista lineasH)  // o H/V
{
  tnodol nodol, nodoli;
  lista nl;
  Boolean corte;
  nl = listaNueva ();
  for (nodol = lineasV->primero; nodol != 0L; nodol = nodol->siguiente) {
    corte = FALSE;
    for (nodoli = lineasH->primero; (nodoli != 0L) && !corte;
                                    nodoli = nodoli->siguiente) {
      corte =  seCortan2 ((tline) nodol->aitem, (tline) nodoli->aitem);
      }
    if (! corte)
      aniadeafinlista (nl, nodol->aitem);
    }
  * lineasVsc = nl;
}

void delimitaParalelogrInterior (tvent *ventn, tvent vent,
              tline linN, tline linS, tline linO, tline linE, int del)
{
  // int tx, ty;
  int dx, dy, dx2, dy2;
  dy  = linN->v1 + 1 + del;
  dy2 = linS->v0 - 1 - del;
  // ty = dy2 - dy + 1;
  dx  = linO->v1 + 1 + del;
  dx2 = linE->v0 - 1 - del;
  // tx = dx2 - dx + 1;
  ventanaLimpParalogrDeVentana (ventn, vent,
                                  linN->incl, dy, dy2, linO->incl, dx, dx2);
}

void delimitaParalelogrExterior (tvent *ventn, tvent vent,
              tline linN, tline linS, tline linO, tline linE, int del)
{
  // int tx, ty;
  int dx, dy, dx2, dy2;
  dy  = linN->v0 - 1 - del;
  dy2 = linS->v1 + 1 + del;
  // ty = dy2 - dy + 1;
  dx  = linO->v0 - 1 - del;
  dx2 = linE->v1 + 1 + del;
  // tx = dx2 - dx + 1;
  ventanaLimpParalogrDeVentana (ventn, vent,
                                  linN->incl, dy, dy2, linO->incl, dx, dx2);
}

