
#include "asocia.h"
#include "base.h"
#include "convcar.h"

static int nlmayusMinus;
static char ** mayusM, ** mayusMinus;
static int nlminusMayus;
static char ** minusM, ** minusMayus;
static int nlchpuntua;
static char ** chpuntua;

void leemayusMinusYrev (char * dir)
{
  leeT2 (dir, "maymin",  &mayusM, &mayusMinus, & nlmayusMinus);
  leeT2 (dir, "minmay",  &minusM, &minusMayus, & nlminusMayus);
}

void leechpuntua (char * dir)
{
  leeT1 (dir, "puntua",  &chpuntua, &nlchpuntua);
}

Boolean minusdeMayus (char *minus, char *mayus)
{
  Boolean res;
  char ustr_mayus [128];
  char ustr_minus [128];
  ustrDeUtf8 (ustr_mayus, mayus);
  res = asocT2 (ustr_mayus, ustr_minus, mayusM, mayusMinus, nlmayusMinus);
  if (res)
    utf8DeUstr (minus, ustr_minus);
  return res;
}

Boolean mayusdeMinus (char *mayus, char *minus)
{
  Boolean res;
  char ustr_mayus [128];
  char ustr_minus [128];
  ustrDeUtf8 (ustr_minus, minus);
  res = asocT2 (ustr_minus, ustr_mayus, minusM, minusMayus, nlminusMayus);
  if (res)
    utf8DeUstr (mayus, ustr_mayus);
  return res;
}

Boolean cambiaMayusMinus (char *salida, char *entrada)
{
  if (minusdeMayus (salida, entrada))
    return TRUE;
  else
    return mayusdeMinus (salida, entrada);
}

Boolean esMinuscula (char *ch)
{
  char uchnada[100];
  char uch[100];
  ustrDeUtf8 (uch, ch);
  return asocT2 (uch, uchnada, minusM, minusMayus, nlminusMayus) ;
}

Boolean esMayuscula (char *ch)
{
  char uchnada[100];
  char uch[100];
  ustrDeUtf8 (uch, ch);
  return asocT2 (uch, uchnada, mayusM, mayusMinus, nlmayusMinus) ;
}

Boolean esLetra (char *ch)
{
  return esMinuscula (ch) ||
	 esMayuscula (ch) ;
}

//   ... a mejorar

Boolean esAmbigua1 (char *chu)
{
  char ch;
  ch = chu[0];
  return (ch == 'C') || (ch == 'O') || (ch == 'S') || 
         (ch == 'U') || (ch == 'V') || (ch == 'W') || 
         (ch == 'X') || (ch == 'Z') ;
}

Boolean esAmbigua2 (char *chu)
{
  char ch;
  ch = chu[0];
  return (ch == 'c') || (ch == 'o') || (ch == 's') || 
         (ch == 'u') || (ch == 'v') || (ch == 'w') || 
         (ch == 'x') || (ch == 'z') ;
}

Boolean eschruPuntuacion (char *chu)
{
  char ustr [128];
  ustrDeUtf8 (ustr, chu);
  return asocT1 (ustr, chpuntua, nlchpuntua);
}

Boolean eschruPuntuacionV (char *chu)
{
  char ch ;
  ch = chu[0];
  return ((ch == ',') || (ch == '') ||
          (ch == '-') || (ch == '!') ||
          (ch == '(') || (ch == '?') ||
          (ch == '') || (ch == '') ||
          (ch == ')') || (ch == '"') ||
          (ch == '`') || (ch == '\047') ||
          (ch == '.') || (ch == '') ||
          (ch == ':') || (ch == ';'));
}

/*    obsoleto, cambiado de  ch  a  *ch  para utf8
 *    vie sep 22 12:30:45 CEST 2006
 * 
Boolean esMinuscula (char ch)
{
  char uchnada[100];
  char uch[100];
  ustrDeUtf8 (uch, &ch);
  // chapuza hasta cambio a unicode
  if ((ch == '') || (ch == '') || (ch == '') ||
      (ch == '') || (ch == '') || (ch == '') ||
      (ch == ''))
    return TRUE;
  if ((ch == '') || (ch == '') || (ch == '') ||
      (ch == '') || (ch == '') || (ch == '') ||
      (ch == ''))
    return FALSE;
  return asocT2 (uch, uchnada, minusM, minusMayus, nlminusMayus) ;
}

Boolean esMayuscula (char ch)
{
  char uchnada[100];
  char uch[100];
  ustrDeUtf8 (uch, &ch);
  // chapuza hasta cambio a unicode
  if ((ch == '') || (ch == '') || (ch == '') ||
      (ch == '') || (ch == '') || (ch == '') ||
      (ch == ''))
    return TRUE;
  if ((ch == '') || (ch == '') || (ch == '') ||
      (ch == '') || (ch == '') || (ch == '') ||
      (ch == ''))
    return FALSE;
  return asocT2 (uch, uchnada, mayusM, mayusMinus, nlmayusMinus) ;
}

Boolean esLetra (char ch)
{
  return esMinuscula (ch) ||
	 esMayuscula (ch) ;
}

Boolean esAmbigua1 (char ch)
{
  return (ch == 'C') || (ch == 'O') || (ch == 'S') || 
         (ch == 'U') || (ch == 'V') || (ch == 'W') || 
         (ch == 'X') || (ch == 'Z') ;
}

Boolean esAmbigua2 (char ch)
{
  return (ch == 'c') || (ch == 'o') || (ch == 's') || 
         (ch == 'u') || (ch == 'v') || (ch == 'w') || 
         (ch == 'x') || (ch == 'z') ;
}

// obsoleta ?
Boolean eschrPuntuacion (char ch)
{
  return ((ch == ',') || (ch == '') ||
          (ch == '-') || (ch == '!') ||
          (ch == '(') || (ch == '?') ||
          (ch == '') || (ch == '') ||
          (ch == ')') || (ch == '"') ||
          (ch == '`') || (ch == '\047') ||
          (ch == '.') || (ch == '') ||
          (ch == ':') || (ch == ';'));
}

*/
