
#include <libintl.h>
#include <locale.h>
#define _(mens) gettext(mens)
#define N_(mens) (mens)

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "config.h"
#include "corteImag.h"
#include "errors.h"
#include "estad.h"
#include "glifos.h"
#include "grises.h"
#include "histos.h"
#include "imag.h"
#include "imagAcum.h"
#include "imagio.h"
#include "imagx.h"
#include "inclina.h"
#include "lectura.h"
#include "line.h"
#include "opcns.h"
#include "parcela.h"
#include "parecido.h"
#include "pinta.h"
#include "plot.h"
#include "reconoce.h"
#include "segmenta0.h"
#include "segmenta.h"
#include "senial.h"
#include "tarea.h"
#include "tfd2d.h"

extern int optind;

void presentaHistogramaVertical (tvent vent)
{
  int hisV[MAXPIXH];
  int nh;
  // tvent vent2;
  prepara (vent);
  /**/
  // histoVer2 (hisV, vent);
  histoVer (hisV, vent);
  presentaHistoVer (&nh, hisV, vent, "sal26v01.dat", "sal26v01.gpt");
  /** /
  ventanaEnVentanaLargHor (&vent2, vent, 0, 100);
  ventanaEnVentanaLargHor (&vent2, vent, 2210, 170);
  vent2->conv = vent->conv;
  histoVer2 (hisV, vent2);
  presentaHistoVer (&nh, hisV, vent2, "sal26v01.dat", "sal26v01.gpt");
  / ** /
  ventanaEnVentanaLargHor (&vent2, vent,2*(vent->ty)/4 - 20, 40);
  vent2->conv = vent->conv;
  histoVer2 (hisV, vent2);
  presentaHistoVer (&nh, hisV, vent2, "sal26v01.dat", "sal26v01.gpt");
  / **/
  para ();
}

void presentaHistogramaVerticalIncl (tvent vent)
{
  int hisV[MAXPIXH];
  int nh;
  int incl;
  prepara (vent);
  incl = -(vent->ty * 11)/41 ;
  incl = -31*256;
  incl = -calculaInclinacionV (vent);  // HH
  printf ("incl(v):% 5d\n", -incl);
  incl = 1590;
  incl = 1590;
 printf ("desviacion tip histograma inclinado: %8.2f\n",
                            desviacionHistV2 (vent, incl) );
  // histoVer2Incl (hisV, vent, incl);
  histoVerIncl (hisV, vent, incl);
  presentaHistoVer (&nh, hisV, vent, "sal26v.dat", "sal26v.gpt");
  para ();
}

void presentaHistogramaVertical3InclCuad (tvent vent)
{
  int hisV[MAXPIXH];
  int nh;
  int incl;
  prepara (vent);
  /*
  printf ("desviacion tip histograma inclinado: %8.2f\n",
                            desviacionHistV2 (vent, incl) );
  */
  for (incl=-70*256; incl<70*256; incl+=256)
    printf ("promedio histograma inclinado cuadr.: incl=%5d, prom= %6.2f\n",
                            incl, promedioHistVCuad (vent, incl) );
  incl = -50*256;
  histoVer3InclCuad (hisV, vent, incl);
  presentaHistoVer (&nh, hisV, vent, "sal26v.dat", "sal26v.gpt");
  para ();
}

void presentaHistogramaHorizontal (tvent vent)
{
  int hisH[MAXPIXV];
  int nh;
  prepara (vent);
  histoHor2 (hisH, vent);
  presentaHistoHorH (&nh, hisH, vent, "sal26h.dat", "sal26h.gpt");
  para ();
}

void presentaLineasParaCorteVertical (tvent vent)
{
  int hisV[MAXPIXH];
  int ktam = 4;
  int nh;
  tvectder vectder;
  tparsSenial parsCorteV;
  histoVer2 (hisV, vent);
  ktam = 15;
  parametrosCorteVertical (& parsCorteV, ktam);
  paraCortes (&vectder, hisV, vent->tx, parsCorteV, "V");
  presentaHisVectder (&nh, hisV, vectder, "sal26v.dat", "sal26v.gpt");
//  para ();
}

void presentaLineasParaCorteVerticalIncl (tvent vent)
{
  int hisV[MAXPIXH];
  int nh;
  tvectder vectder;
  tparsSenial parsCorteV;
  histoVer2 (hisV, vent);
  parametrosCorteVerticalIncl (& parsCorteV, 2);
  paraCortes (&vectder, hisV, vent->tx, parsCorteV, "V");
  presentaHisVectder (&nh, hisV, vectder, "sal26v.dat", "sal26v.gpt");
  para ();
}

void presentaLineasParaCorteHorizontal (tvent vent)
{
  int hisH[MAXPIXV];
  int nh;
  tvectder vectder;
  tparsSenial parsCorteH;
  prepara (vent);
  histoHor2 (hisH, vent);
  parametrosCorteHorizontal (& parsCorteH, 9);   // 4
  paraCortes (&vectder, hisH, vent->ty, parsCorteH, "H");
  presentaHisVectder (&nh, hisH, vectder, "sal26h.dat", "sal26h.gpt");
  para ();
}

void presentaTfdHorizontal (tvent vent)
{
  int hisH[MAXPIXV];
  int nh;
  tveccomplejo vc;
  int *mods;
  int fmax;
  prepara (vent);
  histoHor2 (hisH, vent);
  transfVector (&vc, hisH, vent->ty);
  modulosnVecc (&mods, vc, vent->ty);
  fmax = posmaxv (mods, vent->ty/2);
  printf ("fmax = %4d, pixels = %4d, mod = %3d\n",
           fmax, vent->ty/fmax, mods[fmax]);
  escribModtfeHistoHor ("sal26th.dat", mods, vent->ty);
  escribeComGnuplotSimp ("sal26th.gpt", "sal26th.dat", "1:2");
  tareaGnuplot (&nh, "sal26th.gpt", "400x600");
  para ();
}

void presentaTfdVertical (tvent vent)
{
  int hisV[MAXPIXH];
  int nh;
  tveccomplejo vc;
  int *mods;
  int fmax;
  prepara (vent);
  histoVer2 (hisV, vent);
  transfVector (&vc, hisV, vent->tx);
  modulosnVecc (&mods, vc, vent->tx);
  fmax = posmaxv (mods, vent->tx/2);
  printf ("fmax = %4d, pixels = %4d, mod = %3d\n",
           fmax, vent->tx/fmax, mods[fmax]);
  escribModtfeHistoHor ("sal26tv.dat", mods, vent->tx);
  escribeComGnuplotSimp ("sal26tv.gpt", "sal26tv.dat", "1:2");
  tareaGnuplot (&nh, "sal26tv.gpt", "400x600");
  para ();
}

void presentaDesviacionTipicaCortesVerticales (tvent vent)
{
  int nh;
  int destV[MAXPIXH];
  prepara (vent);
  desvTipVer2 (destV, vent, X_valori[0]);
  escribeHistoVer ("sal26dt.dat", destV, vent);
  escribeComGnuplotSimp ("sal26dt.gpt", "sal26dt.dat", "1:2");
  tareaGnuplot (&nh, "sal26dt.gpt", "600x400");
  para ();
}

void presentaHVmasDTCV (tvent vent)
{
  int hisV[MAXPIXH];
  int nh;
  int destV[MAXPIXH];
  int hvMasDtcv[MAXPIXH];
  int x;
  int * hvMasDtcvProm;
  histoVer (hisV, vent);
  prepara (vent);
  desvTipVer2 (destV, vent, X_valori[0]);
  for (x=0; x < vent->tx; x++) {
    /* destV no esta definido al final cuando la inclinacion != 0 */
    if (x < (vent->tx - abs(X_valori[0])))
      hvMasDtcv[x] = hisV[x] + destV[x]/2;
    else
      hvMasDtcv[x] = hisV[x];
    }
  convolucionPromedio (&hvMasDtcvProm, hvMasDtcv, vent->tx, 10);
  escribeHistoVer ("sal26hmd.dat", hisV, vent);
  /*
  escribeHistoVer ("sal26hmd.dat", hvMasDtcvProm, vent);
  */
  escribeComGnuplotSimp ("sal26hmd.gpt", "sal26hmd.dat", "1:2");
  tareaGnuplot (&nh, "sal26hmd.gpt", "600x400");
  para ();
}

void marcaCajas (tvent vent, int niv)
{
  lista lineas, palabras, caracteres;
  tnodol nodollis, nodolpal;
  segmentaColumnaP (vent);
  lineas = vent->lvint;
  switch (niv){
    case 1:
      pintaRectIntVentanas (lineas);
      break;
    case 2:
      for (nodollis = lineas->primero; nodollis != (tnodol)0L; nodollis = nodollis->siguiente) {
        palabras = ((tvent) nodollis->aitem) ->lvint;
        pintaRectIntVentanas (palabras);
        }
      break;
    case 3:
      for (nodollis = lineas->primero; nodollis != (tnodol)0L; nodollis = nodollis->siguiente) {
        palabras = ((tvent) nodollis->aitem) ->lvint;
        for (nodolpal = palabras->primero; nodolpal != (tnodol)0L; nodolpal = nodolpal->siguiente) {
          caracteres = ((tvent) nodolpal->aitem) ->lvint;
          pintaRectIntVentanas (caracteres);
	  }
        }
      break;
    }
  presentaVentanayPara (vent, "sal26.pgm", 1);
}


void leeyAcumImagen (timagAcum imagAcum, char *fnom)
{
  timagf imag;
  leeImagen (& imag, fnom);
  prepara0 (imag->ven0);
  anyadeImagAcum (imagAcum, imag->ven0);
}

void leeyAcumImagenesdeFlis (timagAcum *nimagAcum, char *flisnom)
{
  FILE * fd;
  char  buf[256] ;
  timagAcum imagAcum;
  imagAcum = creaImagenAcum (8);
  fd = fopen (flisnom, "r");
  compruebaFd (fd, "lisflet", "ocre.pr26.main");
  for (;;) {
    if (fgets (buf, 256, fd) == (char *) NULL)  break;
    buf[strlen(buf)-1] = '\0';
    leeyAcumImagen (imagAcum, buf);
    }
  fclose (fd);
  *nimagAcum = imagAcum ;
}

/*
void presentaHistogramaGrises (tvent vent)
{
  int gr[256];
  int nh;
  struct tcaracHistoGr carHisGr;
  histoGrVentana (gr, vent);
  escribeHistoGr ("sal09.dat", gr);
  caracterizaHistoGris ( &carHisGr, gr);
  escribeCaracHistoGr (&carHisGr);
  presentaHistoGr (&nh, gr, "sal10.dat", "sal10.gpt");
  termina (nh);
  // para ();
}

void presentaCaracHistoGrises (tvent vent)
{
  int gr[256];
  struct tcaracHistoGr carHisGr;
  histoGrVentana (gr, vent);
  escribeHistoGr ("sal09.dat", gr);
  caracterizaHistoGris ( &carHisGr, gr);
  escribeCaracHistoGr (&carHisGr);
}
*/

void presentaCaracHistoGrises2 (tvent vent)
{
  int gr[256];
  struct tcaracHistoGr carHisGr;
  tvent nvent;
  ventanaEnVentanaCentrada (&nvent, vent, vent->tx/10, vent->ty/10);
  histoGrVentana (gr, nvent);
  escribeHistoGr ("sal09.dat", gr);
  caracterizaHistoGris ( &carHisGr, gr);
  escribeCaracHistoGr (&carHisGr);
  exit (0);
}

void procesa2HojasLibro (tvent vent)
{
  printf ("separa hojas\n");
  printf ("corrige grises\n");
  printf ("procesa cada hoja\n");
}

void opcionesP (tvent vent)
{
  int nc;
  /*
  if (b_opcion) {
    procesa2HojasLibro (vent);
    exit (0);
    }
    */
  switch (p_valori){
    case 1:
      presentaHistogramaVertical (vent);
      break;
    case 2:
      presentaHistogramaHorizontal (vent);
      break;
    case 3:
      segmentaColumnaP (vent);
/*
      presentaHistogramaVertical (seleccionaSubventana (vent, "cadr"));
*/
      presentaHistogramaVertical (seleccionaSubventana (vent, "caddddddddddddddddddddr"));
      break;
    case 4:
      presentaHistogramaVerticalIncl (vent);
      /*
      segmentaColumnaP (vent);
      presentaHistogramaVerticalIncl (seleccionaSubventana (vent, "cadr"));
      */
      break;
    case 6:
      {
      char subven[] = "cadr";
      segmentaColumnaP (vent);
      describeVentana (vent);
      describeVentana (seleccionaSubventana (vent, subven));
      presentaLineasParaCorteVertical (seleccionaSubventana (vent, subven));
      presentaVentanayPara (seleccionaSubventana (vent, subven), "sal14b.pgm", 1);
      }
      break;
    case 7:
      segmentaColumnaP (vent);
      presentaLineasParaCorteVerticalIncl (seleccionaSubventana (vent, "car"));
      break;
    case 8:
      presentaLineasParaCorteHorizontal (vent);
      break;
    case 9:
      presentaTfdHorizontal (vent);
      break;
    case 10:
      presentaTfdVertical (vent);
      break;
    case 11:
      presentaDesviacionTipicaCortesVerticales (vent);
      break;
    case 12:
      presentaHVmasDTCV (vent);
      break;
    case 13:
      marcaCajas (vent, 2);
      break;
    case 23:
      marcaCajas (vent, 3);
      break;
    case 14:
      {
      tvent venti2, venti3;
/*
      int nh;
*/
      ventanaEnVentana (&venti2, vent,
                         495, 249, 48, 33);
      venti2->incl = -62+256 ;
/*
      pintaRectIntVent (venti2);
      presentaVentana (&nh, vent, "sal14a.pgm", 1);
      ventanaVertDeVentanaIncl (&venti3, venti2);
*/
      ventanaLimpConMargenDeVentanaIncl (& venti3, venti2, 220, 1);
      presentaVentanayPara (venti3->imaBase->ven0, "sal14b.pgm", 4);
      exit (0);
      }
      break;
    case 15:
      {
        int cdgx, cdgy;
        prepara (vent);
        cdgVentana(&cdgx, &cdgy, vent, 8);
        printf ("cdg: x=%4d y=%4d\n", cdgx, cdgy);
      }
      exit (0);
      break;
    case 16:
      {
        timagAcum imagAcum;
        timagf imaga;
        timagf imagaf;
        int gr[256];
        struct tcaracHistoGr carHisGr;
        leeyAcumImagenesdeFlis (&imagAcum, "lisflet");
/*
        {
        int x,y;
        for (y=0; y<imagAcum->ty; y++)
        for (x=0; x<imagAcum->tx; x++)
          printf ("x=%03d y=%03d %6d\n", x, y, imagAcum->pix[y][x]);
	}
*/
        histoGrImagAcum (gr, imagAcum);
        caracterizaHistoGris ( &carHisGr, gr);
/*
        escribeCaracHistoGr (&carHisGr);
	{
        int nh;
        presentaHistoGr (&nh, gr, "sal26.dat", "sal26.gpt");
	}
*/
        imagenDeImagenAcum (&imaga, imagAcum);
	transfVentDI (& imagaf, imaga->ven0);
/*
        {
	int tamcorte;
	vectint corte;
        cortaRi (&corte, &tamcorte, imaga->ven0, 74, 24, 110, 160);
        cortaRi (&corte, &tamcorte, imaga->ven0,100,140, 120, 160);
	for (i=0; i<tamcorte; i++) {
	int i;
	  printf ("%4d %4d\n", i, corte [i]);
	  }
	cuadricula (imaga->ven0, 20);
        pintaRin2 (imaga->ven0, 74, 24, 110, 160, 2);
        pintaRin2 (imaga->ven0,100,140, 120, 160, 2);
        pintaRin2 (imaga->ven0, 28, 56,  20,  48, 2);
        pintaRin2 (imaga->ven0,123, 88,  14,  49, 2);
        pintaRin2 (imaga->ven0, 75, 75,  40,  80, 2);
        }
*/
	/*
	*/
        presentaVentanayPara (imagaf->ven0, "sal26e.pgm", 1);
      }
      exit (0);
      break;
/*
    case 17:
      {
        int inclv;
	tvent vz;
        inclv = calculaInclinacionV (vent);
        printf ("inclinacion vertical: %3d\n", inclv);
        presentaHistogramaVerticalIncl (vent);
        zonas (vent);
	vz = seleccionaSubventana (vent, "caddr");
        describeVentana (vz);
        presentaVentanayPara (vz, "sal26f.pgm", 1);
      }
      exit (0);
      break;
*/
    case 18:
      prepara0 (vent);
      sigueRayas (vent); 
      exit (0);
      break;
    case 19:
      {
	tnodol nodol;
	tglifo glifoColumnaP;
	prepara0 (vent);
	parcela (vent);
	nc = 0;
	for (nodol = vent->lvint->primero; nodol != (tnodol)0L; nodol = nodol->siguiente) {
          segmReconoceyRepasaColumnaP ( &glifoColumnaP, (tvent) nodol->aitem, &nc );
           }
	/*
        segmReconoceyRepasaColumnaP ( &glifoColumnaP, seleccionaSubventana (vent, "car"));
        segmReconoceyRepasaColumnaP ( &glifoColumnaP, seleccionaSubventana (vent, "cadr"));
        segmReconoceyRepasaColumnaP ( &glifoColumnaP, seleccionaSubventana (vent, "caddr"));
	*/
	/*
	*/
	printf ("preguntas: %4d\n", cuantasPreguntas());
        exit (0);
      }
      exit (0);
      break;
    case 20:
      {
        segmentaColumnaP (vent);
      }
      exit (0);
      break;
    case 21:
      {
        segmentaColumnaP (vent);
	pintaRectIntVent (seleccionaSubventana (vent, "cadr"));
	pintaRectIntVent (seleccionaSubventana (vent, "cadaddr"));
	pintaRectIntVent (seleccionaSubventana (vent, "cadddaaddr"));
	/*
	pintaRectIntVent (seleccionaSubventana (vent, "cadadddaddr"));
	*/
        presentaVentanayPara (vent, "sal26g.pgm", 1);
      }
      exit (0);
      break;
    case 24:
      segmentaColumnaP (vent);
      presentaHistogramaVertical3InclCuad (seleccionaSubventana (vent, "cadddar"));
      break;
    case 25:
      parcela (vent);
/** /
      segmReconoceyRepasaColumnaP ( &glifoColumnaP, seleccionaSubventana (vent, "caaadr"));
      segmReconoceyRepasaColumnaP ( &glifoColumnaP, seleccionaSubventana (vent, "caddaadr"));
      segmReconoceyRepasaColumnaP ( &glifoColumnaP, seleccionaSubventana (vent, "caddddaadr"));
      segmReconoceyRepasaColumnaP ( &glifoColumnaP, seleccionaSubventana (vent, "cadadadr"));
      segmReconoceyRepasaColumnaP ( &glifoColumnaP, seleccionaSubventana (vent, "cadddadadr"));
      segmReconoceyRepasaColumnaP ( &glifoColumnaP, seleccionaSubventana (vent, "cadddddadadr"));
/ ** /
      parcela (vent);
      segmReconoceyRepasaColumnaP ( &glifoColumnaP, seleccionaSubventana (vent, "caadaadr"));
      segmReconoceyRepasaColumnaP ( &glifoColumnaP, seleccionaSubventana (vent, "caadddaadr"));
      segmReconoceyRepasaColumnaP ( &glifoColumnaP, seleccionaSubventana (vent, "caaadadr"));
      segmReconoceyRepasaColumnaP ( &glifoColumnaP, seleccionaSubventana (vent, "caaddadadr"));
      segmReconoceyRepasaColumnaP ( &glifoColumnaP, seleccionaSubventana (vent, "caaddddadadr"));
/ **/
      break;
/*
    case 26:
      presentaHistogramaGrises (vent);
      break;
    case 27:
      presentaCaracHistoGrises (vent);
      exit (0);
      break;
*/
    case 28:
      presentaCaracHistoGrises2 (vent);
      break;
    case 30:
      {
      tvent vent2;
      ventanaEnVentanaLargHor (&vent2, vent, vent->ty/10, 100);
      presentaHistogramaVertical (vent2);
      }
      break;
    }
}
