
#include <stdio.h>
#include <stdlib.h>

#include "aplica.h"
#include "base.h"
#include "config.h"
#include "estad.h"
#include "glifos.h"
#include "grises.h"
#include "grises0.h"
#include "histos.h"
// #include "inclfont.h"
#include "inclina0.h"
#include "inclina.h"
#include "imag.h"
#include "imagio.h"
#include "line.h"
#include "lista.h"
#include "lvent.h"
#include "opcns.h"
#include "pinta.h"
#include "segmen.h"
#include "senial.h"
#include "tfd2d.h"
#include "imagx.h"
#include "tarea.h"


// int d_segmenta = 0; //


// histograma horizontal ... TF ... (muchas lineas)
int proponerKtamenVentana2 (tvent vent)
{
  int hisH[MAXPIXV];
  tveccomplejo vc;
  int *mods;
  int fmax, pixels;
  int ty;
  // int i;
  int ktam = -1;
  ty = vent->ty ;
  histoHor2 (hisH, vent);
  transfVector (&vc, hisH, ty);
  modulosnVecc (&mods, vc, ty);
  // for (i=0;i<=ty/2;i++) printf("## %4d %5d\n",i,mods[i]);
  fmax = posmaxv3 (mods, 1, ty/2-1);
  pixels = ty / fmax;
  //if ((pixels <= 80) && (mods[fmax] > 90)) {
  if ((pixels <= 290) && (mods[fmax] > 90)) {
    // printf(" POR  AQUI %d %d \n", pixels, mods[fmax]); //
    ktam = pixels / 10 ;
    //  vent->ktam = ktam;
    }
  if (d_valori >= 10)
    printf ("ocre: segmenta.proponerKtamenVentana2\n") ;
  return ktam;
}

// histograma horizontal ... segmento negros mas largo (linea mas ancha)
int proponerKtamenVentana3 (tvent vent)
{
  int hisH[MAXPIXV];
  int mx, mn, md;
  lista segm;
  int ty;
  int porcClaro = 70;
  // int mxq;
  int c0, c1, xmxq;
  int ktam;
  tsegm segmmx;
  ty = vent->ty ;
  histoHor2 (hisH, vent);
  mx =maxv (hisH, ty);
  mn =minv (hisH, ty);
  md = (mx*porcClaro+mn*(100-porcClaro))/100;
  // printf ("mn: %4d, mx: %4d, md: %4d, porcClaro: %4d\n", mn, mx, md, porcClaro);
  segmentosBajoUmbral (&segm, hisH, ty, md);
  // para eliminar extremos
  if (longLista(segm) == 0)
    return -1;
  if (((tsegm)segm->primero->aitem)->u0 == 0)
    c0 = ((tsegm)segm->primero->aitem)->u1 + 1;
  else
    c0 = 0;
  if (((tsegm)segm->ultimo->aitem)->u1 == ty-1)
    c1 = ((tsegm)segm->ultimo->aitem)->u0 - 1;
  else
    c1 = ty-1;
  // en lo que queda
  // mxq  = minv3 (hisH, c0, c1 );
  xmxq = posminv3 (hisH, c0, c1 );
  enSegmento (&segmmx, segm, xmxq);
//  printf ("c0=%4d c1=%4d xmxq = %4d\n", c0, c1, xmxq );      //
//  imprimeSegmentos (segm);                                   //
//  printf ("u0=%4d u1=%4d \n", segmmx->u0, segmmx->u1 );      //
  ktam = tamanyoSegm (segmmx) / 5 ;
  // vent->ktam = ktam ;
  liberaItemsNodosYlista (segm) ;
  if (d_valori >= 10)
    printf ("ocre: segmenta.proponerKtamenVentana3\n") ;
  return ktam;
}

void proponerKtamenVentana (tvent vent)
{
  int ktam, ktam2, ktam3;
  ktam2 = proponerKtamenVentana2 (vent);
  ktam3 = proponerKtamenVentana3 (vent);
  if (ktam2 == -1)
    ktam = ktam3;
  else
    ktam = (ktam2 + ktam3) / 2 ;
  vent->ktam = ktam ;
  if (d_valori >= 10) {
    printf ("segmenta0.proponerKtamenVentana: ktam=%d\n", ktam);
    printf ("     ktam2: %d, ktam3: %d\n", ktam2, ktam3);
    describeVentana (vent);
    }
}

void prepara (tvent vent)
{
  int incl;
  incl = calculaInclinacionH (vent);
  giroPeqH (vent, incl);
  prepara0 (vent);
  proponerKtamenVentana (vent);
  if (d_valori >= 10)
    printf ("ocre: segmenta0.prepara\n") ;
}

Boolean masOscuro (int y, tvectder vectder)
{
  return vectder->prom[y] < vectder->umbr[y] ;
}

Boolean aOscuro (int y, tvectder vectder)
{
  return ! masOscuro (y, vectder) && masOscuro (y+1, vectder) ;
}

Boolean aClaro (int y, tvectder vectder)
{
  return  masOscuro (y, vectder) && ! masOscuro (y+1, vectder) ;
}

//-----------------------------------------------------

void cortaLin (lista *nblos, tvectder vectder, int tv)
{
                  // version simplificada  para dos cortes
  lista blos;
  int y;
  int comienzolin = 0;  // '= 0' concesion a avisos (warning)
  blos = listaNueva () ;
  if (masOscuro (0, vectder)) comienzolin = 0;
  for (y=0; y<=tv-2; y++){
    if (aOscuro(y, vectder)){
      comienzolin = y+1;
      }
    if (aClaro(y, vectder)){
      anyadeSegm (blos, comienzolin, y);
      }
    }
  if (masOscuro (tv-1, vectder)){
    anyadeSegm (blos, comienzolin, tv-1);
    }
  *nblos = blos;
  if (d_valori >= 30)
    imprimeSegmentos (blos);
  if (d_valori >= 10)
    printf ("ocre: cortaLin, %d lineas\n", longLista(blos)) ;
}
