
#include <stdlib.h>
#include <stdio.h>

#include "aplica.h"
#include "errors.h"
#include "estad.h"
#include "opcns.h"
#include "plot.h"
#include "senial.h"
#include "tarea.h"

tvectder vectderAlloc (int n)
{
  tvectder vectder;
  vectder = (tvectder) malloc ( sizeof(struct tvder) );
  vectder->n     = n;
  vectder->deriv = FALSE;
  vectder->mins  = (int *) malloc (n * sizeof(int));
  vectder->maxs  = (int *) malloc (n * sizeof(int));
  vectder->minsp = (int *) malloc (n * sizeof(int));
  vectder->maxsp = (int *) malloc (n * sizeof(int));
  vectder->prom  = (int *) malloc (n * sizeof(int));
  vectder->umbr  = (int *) malloc (n * sizeof(int));
  return vectder;
}

tvectder dervectder (tvectder vectder, int del, int n)
{
  tvectder dvectder;
  /* if (vectder->n < del+n) { printf("error\n"); exit  */
  dvectder = (tvectder) malloc ( sizeof(struct tvder) );
  dvectder->n     = n;
  dvectder->deriv = TRUE;
  dvectder->mins  = (int *) &(vectder->mins [del]);
  dvectder->maxs  = (int *) &(vectder->maxs [del]);
  dvectder->minsp = (int *) &(vectder->minsp[del]);
  dvectder->maxsp = (int *) &(vectder->maxsp[del]);
  dvectder->prom  = (int *) &(vectder->prom [del]);
  dvectder->umbr  = (int *) &(vectder->umbr [del]);
  return dvectder;
}

void vectderFree (tvectder vectder)
{
  if (! vectder->deriv) {
    free (vectder->mins);
    free (vectder->maxs);
    free (vectder->minsp);
    free (vectder->maxsp);
    free (vectder->prom);
    free (vectder->umbr);
    }
  free (vectder);
}

void paraCortes (tvectder *nvectder, int *his, int tv, tparsSenial parsCorte, char *nomCor)
{
  tvectder vectder;
  int i;  
  vectder = vectderAlloc (tv);
  aplicaV(his,           vectder->maxs,  tv, parsCorte.anMax    , maxv) ; 
  aplicaV(vectder->maxs, vectder->maxsp, tv, parsCorte.anPromMax, prom) ; 
  aplicaV(his,           vectder->mins,  tv, parsCorte.anMin    , minv) ; 
  aplicaV(vectder->mins, vectder->minsp, tv, parsCorte.anPromMin, prom) ; 
  aplicaV(his,           vectder->prom,  tv, parsCorte.anProm   , prom) ; 
  for(i=0;i<tv;i++)
    vectder->umbr[i] = ((parsCorte.nivCh  * vectder->minsp[i]) +
                 ((256 - parsCorte.nivCh) * vectder->maxsp[i]) )/256;
  if (d_valori >= 10)
    printf ("ocre: paraCortes%s,\n", nomCor) ;
  if (( d_valori >= 30) ||
      ((d_valori >= 20) && (nomCor[0] == 'H')) )
    for(i=0;i<tv;i++)
        printf("paraCortes%s, %4d %7d %7d %7d %7d %7d %7d %7d\n", 
                nomCor, i, his[i],
                vectder->maxs[i],   vectder->maxsp[i],
                vectder->mins[i],   vectder->minsp[i],
                vectder->umbr[i],   vectder->prom[i]  );
  *nvectder = vectder;
}

void  escribeHisVectder (char *nf, int * his, tvectder vectder)
{
  FILE * fd;
  int i, n;
  fd = fopen (nf, "w");
  compruebaFd (fd, nf, "senial.escribeHisVectder");
  n  = vectder->n ;
  for(i=0;i<n;i++)
      fprintf(fd, "%4d %7d %7d %7d %7d %7d %7d %7d\n",
              i, his[i],
              vectder->maxs[i],   vectder->maxsp[i],
              vectder->mins[i],   vectder->minsp[i],
              vectder->umbr[i],   vectder->prom[i]  );
  fclose(fd);
}

void presentaHisVectder (int *nnh, int * his, tvectder vectder, char *nfd, char *nfi)
{
  escribeHisVectder (nfd, his, vectder);
  escribeComGnuplotMult (nfi, nfd,  7,      "1:2", "histo",
                          "1:3", "maxs",    "1:4", "maxsp",
                          "1:5", "mins",    "1:6", "minsp",
                          "1:7", "umbr",    "1:8", "prom"   );
  tareaGnuplot (nnh, nfi, "600x400");
}

void convolucionPromedio (int ** nvs, int * ve, int tamVec, int anchProm)
{
  int * vs;
  vs = (int *) malloc (tamVec * sizeof (int));
  aplicaV (ve, vs, tamVec, anchProm, prom) ;
  *nvs = vs;
}

void convolucionDifPromedio (int ** nvs, int * ve, int tamVec, int anchProm)
{
  int * vs;
  vs = (int *) malloc (tamVec * sizeof (int));
  aplicaV (ve, vs, tamVec, anchProm, difprom) ;
  *nvs = vs;
}

void convolucionDif2Promedio (int ** nvs, int * ve, int tamVec, int anchProm)
{
  int * vs;
  vs = (int *) malloc (tamVec * sizeof (int));
  aplicaV (ve, vs, tamVec, anchProm, dif2prom) ;
  *nvs = vs;
}
